"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ActivityIndicator = _interopRequireDefault(require("./ActivityIndicator"));
var _FadeInOut = _interopRequireDefault(require("./FadeInOut"));
var _excluded = ["buttonRef", "component", "link", "wait", "busy", "disabled", "action", "onClick", "submit", "stretch", "style", "className", "children"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = _react["default"].PureComponent || _react["default"].Component;
var Button_ = /*#__PURE__*/function (_PureComponent) {
  _inherits(Button_, _PureComponent);
  var _super = _createSuper(Button_);
  function Button_() {
    var _this;
    _classCallCheck(this, Button_);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {});
    _defineProperty(_assertThisInitialized(_this), "linkOnClick", function (event) {
      var _this$props = _this.props,
        wait = _this$props.wait,
        busy = _this$props.busy,
        disabled = _this$props.disabled,
        action = _this$props.action,
        onClick = _this$props.onClick;

      // Only handle left mouse button clicks
      // ignoring those ones with a modifier key pressed.
      if (event.button !== 0 || event.shiftKey || event.altKey || event.ctrlKey || event.metaKey) {
        return;
      }
      if (wait || busy || _this.state.wait || disabled) {
        return;
      }

      // Could be just a "submit" button without having any `action`.
      // Could also be just a `link` button.
      // Therefore "preventing default" only if `action` is set:
      // for example, if `link` is set and no `action`
      // then it should proceed with navigating to the `link`.
      // And if `link` is set and `action` is specified too
      // then it will prevent it from navigating to the `link`.
      if (action || onClick) {
        event.preventDefault();
      }
      _this.buttonOnClick();
    });
    _defineProperty(_assertThisInitialized(_this), "buttonOnClick", function (event) {
      var _this$props2 = _this.props,
        action = _this$props2.action,
        onClick = _this$props2.onClick;
      var result;
      // Could be just a `<button type="submit"/>`
      // without any `action` supplied.
      if (action) {
        result = action();
      } else if (onClick) {
        result = onClick();
      }
      if (result && typeof result.then === 'function') {
        _this.setState({
          wait: true
        });
        result.then(function () {
          return _this._isMounted && _this.setState({
            wait: false
          });
        }, function () {
          return _this._isMounted && _this.setState({
            wait: false
          });
        });
      }
    });
    return _this;
  }
  _createClass(Button_, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        buttonRef = _this$props3.buttonRef,
        component = _this$props3.component,
        link = _this$props3.link,
        wait = _this$props3.wait,
        busy = _this$props3.busy,
        disabled = _this$props3.disabled,
        action = _this$props3.action,
        onClick = _this$props3.onClick,
        submit = _this$props3.submit,
        stretch = _this$props3.stretch,
        style = _this$props3.style,
        className = _this$props3.className,
        children = _this$props3.children,
        rest = _objectWithoutProperties(_this$props3, _excluded);
      var properties = _objectSpread(_objectSpread({}, rest), {}, {
        ref: buttonRef,
        style: style,
        className: (0, _classnames["default"])(className, 'rrui__input', 'rrui__button-reset', 'rrui__outline', 'rrui__button', {
          'rrui__button--busy': wait || busy || this.state.wait,
          'rrui__button--disabled': disabled,
          'rrui__button--stretch': stretch,
          'rrui__button-reset--link': link
        })
      });
      if (link) {
        var LinkComponent = component || 'a';
        return /*#__PURE__*/_react["default"].createElement(LinkComponent, _extends({
          href: component ? undefined : link,
          onClick: this.linkOnClick
        }, properties), children);
      }
      return /*#__PURE__*/_react["default"].createElement("button", _extends({
        type: submit ? 'submit' : 'button',
        disabled: wait || busy || this.state.wait || disabled,
        onClick: this.buttonOnClick
      }, properties), /*#__PURE__*/_react["default"].createElement(_FadeInOut["default"], {
        show: wait || busy || this.state.wait,
        fadeOutDuration: 300,
        fadeInClassName: "rrui__button__busy--after-show"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "rrui__button__busy"
      })), children);
    }
  }]);
  return Button_;
}(PureComponent);
var Button = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  return /*#__PURE__*/_react["default"].createElement(Button_, _extends({}, props, {
    buttonRef: ref
  }));
});
Button.propTypes = {
  // onClick handler.
  // Doesn't receive `event` by default.
  // Can be `async`/`await` or return a `Promise`
  // in which case it will show "wait" animation.
  onClick: _propTypes["default"].func,
  // onClick handler.
  // (deprecated, use `onClick(event)` instead)
  action: _propTypes["default"].func,
  // If `wait` is `true` then the button
  // will be disabled and a spinner will be shown.
  wait: _propTypes["default"].bool,
  // (deprecated)
  // (use `wait` instead)
  // If `busy` is `true` then the button
  // will be disabled and a spinner will be shown.
  busy: _propTypes["default"].bool,
  // Disables the button
  disabled: _propTypes["default"].bool,
  // When `true`, the button will submit an enclosing form.
  submit: _propTypes["default"].bool,
  // If `link` is set, then the button is gonna be an <a/> tag.
  link: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  // Custom React component for the button.
  component: _propTypes["default"].func,
  // Set to `true` to stretch the button to full width.
  stretch: _propTypes["default"].bool,
  // CSS style object for the button container
  style: _propTypes["default"].object,
  // CSS class name
  className: _propTypes["default"].string
};
var _default = Button;
exports["default"] = _default;
//# sourceMappingURL=Button.js.map