"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactDayPicker = _interopRequireWildcard(require("react-day-picker"));
var _TextInputComponent = _interopRequireDefault(require("./TextInputComponent"));
var _Expandable = _interopRequireDefault(require("./Expandable"));
var _YearMonthSelect = _interopRequireDefault(require("./YearMonthSelect"));
var _WithError = _interopRequireDefault(require("./WithError"));
var _reduxForm = require("./utility/redux-form");
var _focus = require("./utility/focus");
var _dom = require("./utility/dom");
var _getFirstDayOfWeek = _interopRequireDefault(require("./utility/getFirstDayOfWeek"));
var _getDateForDayOfWeek = _interopRequireDefault(require("./utility/getDateForDayOfWeek"));
var _getDateForMonth = _interopRequireDefault(require("./utility/getDateForMonth"));
var _formatDate = _interopRequireDefault(require("./utility/formatDate"));
var _ignoreInvalidDateObjects = _interopRequireDefault(require("./utility/ignoreInvalidDateObjects"));
var _transformDateInputAccordingToTemplate = _interopRequireDefault(require("./utility/transformDateInputAccordingToTemplate"));
var _parseDate = _interopRequireWildcard(require("./utility/parseDate"));
var _excluded = ["format", "utc", "value", "error", "showErrorMessage", "disabledDays", "selectYearsIntoPast", "selectYearsIntoFuture", "initialCalendarDate", "locale", "label", "alignment", "waitForKeyboardSlideIn", "keyboardSlideInAnimationDuration", "buttonAriaLabel", "closeLabel", "closeButtonIcon", "icon", "className", "style", "onChange", "onBlur", "onToggle", "onFocus", "onKeyDown"]; // https://github.com/gpbl/react-day-picker/tree/v7/src
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var DatePicker = function DatePicker(_ref, ref) {
  var formatAnyCase = _ref.format,
    utc = _ref.utc,
    value = _ref.value,
    error = _ref.error,
    showErrorMessage = _ref.showErrorMessage,
    disabledDays = _ref.disabledDays,
    selectYearsIntoPast = _ref.selectYearsIntoPast,
    selectYearsIntoFuture = _ref.selectYearsIntoFuture,
    initialCalendarDate = _ref.initialCalendarDate,
    locale = _ref.locale,
    label = _ref.label,
    alignment = _ref.alignment,
    waitForKeyboardSlideIn = _ref.waitForKeyboardSlideIn,
    keyboardSlideInAnimationDuration = _ref.keyboardSlideInAnimationDuration,
    buttonAriaLabel = _ref.buttonAriaLabel,
    closeLabel = _ref.closeLabel,
    CloseButtonIcon = _ref.closeButtonIcon,
    icon = _ref.icon,
    className = _ref.className,
    style = _ref.style,
    onChange = _ref.onChange,
    onBlur = _ref.onBlur,
    onToggle = _ref.onToggle,
    onFocus = _ref.onFocus,
    onKeyDown = _ref.onKeyDown,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useState = (0, _react.useState)(),
    _useState2 = _slicedToArray(_useState, 2),
    isExpanded_ = _useState2[0],
    setExpanded = _useState2[1];
  var _useState3 = (0, _react.useState)(),
    _useState4 = _slicedToArray(_useState3, 2),
    month = _useState4[0],
    setMonth = _useState4[1];
  var _useState5 = (0, _react.useState)(),
    _useState6 = _slicedToArray(_useState5, 2),
    textValue = _useState6[0],
    setTextValue = _useState6[1];
  var userHasJustChangedYearOrMonthTimer = (0, _react.useRef)();
  var _userHasJustChangedYearOrMonth = (0, _react.useRef)();
  var hasDayJustBeenSelected = (0, _react.useRef)();
  var isFocusingOut = (0, _react.useRef)();
  var blurTimer = (0, _react.useRef)();
  var container = (0, _react.useRef)();
  var expandable = (0, _react.useRef)();
  var input = (0, _react.useRef)();
  var inputOverlay = (0, _react.useRef)();
  var calendar = (0, _react.useRef)();
  var hasMounted = (0, _react.useRef)();

  // `format` should be in lower case.
  var format = (0, _react.useMemo)(function () {
    return formatAnyCase.toLowerCase();
  }, [formatAnyCase]);
  (0, _react.useEffect)(function () {
    if (hasMounted.current) {
      if (value) {
        if (calendar.current) {
          calendar.current.showMonth(value);
        }
      }
    }
  }, [value]);
  (0, _react.useEffect)(function () {
    hasMounted.current = true;
    return function () {
      clearTimeout(userHasJustChangedYearOrMonthTimer.current);
      clearTimeout(blurTimer.current);
    };
  }, []);
  var expand = (0, _react.useCallback)(function () {
    return expandable.current.expand();
  }, []);
  var collapse = (0, _react.useCallback)(function () {
    return expandable.current.collapse();
  }, []);
  var toggle = (0, _react.useCallback)(function () {
    return expandable.current.toggle();
  }, []);
  var isExpanded = (0, _react.useCallback)(function () {
    return expandable.current.isExpanded();
  }, []);
  var focus = (0, _react.useCallback)(function () {
    input.current.focus();
  }, []);
  var focusCalendar = (0, _react.useCallback)(function () {
    if (calendar.current) {
      var dayPicker = calendar.current.dayPicker;
      if (dayPicker) {
        var selectedDay = dayPicker.querySelector('.DayPicker-Day[aria-disabled=false][aria-selected=true]');
        if (selectedDay) {
          return selectedDay.focus();
        }
        var anyDay = dayPicker.querySelector('.DayPicker-Day[aria-disabled=false]');
        if (anyDay) {
          return anyDay.focus();
        }
        return dayPicker.firstChild.focus();
      }
    }
  }, []);
  var userHasJustChangedYearOrMonth = (0, _react.useCallback)(function () {
    _userHasJustChangedYearOrMonth.current = true;
    clearTimeout(userHasJustChangedYearOrMonthTimer.current);
    userHasJustChangedYearOrMonthTimer.current = setTimeout(function () {
      _userHasJustChangedYearOrMonth.current = false;
    }, 50);
  }, []);
  var onInputFocus = (0, _react.useCallback)(function (event) {
    if (onFocus) {
      onFocus(event);
    }
    // if (!focusAfterDaySelected) {
    // 	expand()
    // }
  }, [onFocus]);
  var onExpand = (0, _react.useCallback)(function () {
    // Reset the month previously selected via the month `<select/>`.
    // `month` could previously be set to some value via the month `<select/>`,
    // and, since that value wasn't been cleared, it would be "stuck"
    // and the calendar would open at that previously selected month again,
    // even though `value` or `initialCalendarDate` are defined and correspond to
    // a different month.
    //
    // `setMonth()` should be called in `onExpand()` rather than in `onExpanded()`
    // with `setTimeout()` because by the time the calendar is expanded, the correct
    // month has to be already selected in order to `focusCalendar()` to focus
    // a correct day. Otherwise, it would focus some day of some month, and then
    // the correct month would be automatically selected and the focus would be "lost".
    setMonth(value ? (0, _ignoreInvalidDateObjects["default"])(value) : initialCalendarDate || new Date());

    // Must re-calculate `textValue` on each "expand"
    // because it's being reset on each "collapse".
    setTextValue((0, _formatDate["default"])(value, format, {
      utc: utc
    }));

    // For `aria-expanded`.
    setExpanded(true);
  }, [value, format, utc, initialCalendarDate]);
  var onExpanded = (0, _react.useCallback)(function () {
    // Set "previous" and "next" buttons untabbable
    // so that a Tab out of the `<input/>` field
    // moves cursor not inside to these buttons
    // but rather to the first day of the month. // next form input.
    //
    // (rewritten)
    // Requires ES6 Symbol.Iterator polyfill.
    // for (const button of calendar.querySelectorAll('.DayPicker-NavButton'))
    //
    // The user can still navigate via Up/Down arrow keys
    // when the focus is on a calendar date.
    // Or the user can enter the date in the `<input/>` text field.
    //
    // https://github.com/gpbl/react-day-picker/issues/848
    //
    for (var _iterator = _createForOfIteratorHelperLoose([].slice.call(container.current.querySelectorAll('.DayPicker-NavButton'))), _step; !(_step = _iterator()).done;) {
      var button = _step.value;
      button.setAttribute('tabindex', '-1');
    }

    // A workaround for a bug where `tabIndex` of the "wrapper" div is `0`
    // and at the same time there's no `aria-label`.
    // https://github.com/gpbl/react-day-picker/issues/848
    container.current.querySelector('.DayPicker-wrapper').setAttribute('tabindex', -1);
    // Could also potentially update `aria-label` attribute to (month + year)
    // on expand and on month/year change in the expanded calendar.
    // But that would be too much hassle.
  }, []);

  // Cancels textual date editing.
  var onCollapse = (0, _react.useCallback)(function (_ref2) {
    var focusOut = _ref2.focusOut;
    if (!focusOut && !isFocusingOut.current && !hasDayJustBeenSelected.current) {
      focus();
    }

    // Reset any custom `textValue` and use the formatted `value` instead.
    setTextValue();

    // Set `aria-expanded` attribute to `false`.
    setExpanded(false);

    // `onChange` fires on calendar day `click`
    // but the `value` hasn't neccessarily been updated yet,
    // therefore, say, if `value` was not set
    // and a user selects a day in the calendar
    // then the `value` is technically still `undefined`
    // so can't just set `state.textValue = formatDate(value, ...)` here.
    //
    // Analogous, `setState({ textValue })` has been called
    // in calendar day `onClick` handler but `state.textValue`
    // hasn't neccessarily been updated yet.
    //
    // Still must validate (recompute) `textValue`
    // upon expanding the `<DatePicker/>`, for example, on `<input/>` blur
    // in cases when a user manually typed in an incomplete date and then tabbed away.
  }, [focus]);
  var onContainerKeyDown = (0, _react.useCallback)(function (event) {
    if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
      return;
    }
    switch (event.keyCode) {
      // "Escape".
      //
      // Collapse.
      //
      // Maybe add this kind of support for "Escape" key in some future:
      //  hiding the item list, cancelling current item selection process
      //  and restoring the selection present before the item list was toggled.
      //
      case 27:
        event.preventDefault();
        // Collapse the list if it's expanded.
        return collapse();

      // On "Up" arrow.
      case 38:
      // On "Down" arrow.
      case 40:
        return event.preventDefault();
    }
  }, [collapse]);
  var onToggleButtonClick = (0, _react.useCallback)(function (event) {
    toggle().then(function () {
      if (isExpanded_) {
        focusCalendar();
      }
    });
  }, [isExpanded_, toggle, focusCalendar]);
  var onInputKeyDown = (0, _react.useCallback)(function (event) {
    if (onKeyDown) {
      onKeyDown(event);
    }
    if (event.defaultPrevented) {
      return;
    }
    if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
      return;
    }
    switch (event.keyCode) {
      // On "Enter".
      case 13:
        if (isExpanded()) {
          // Don't "prevent default" here
          // in order for a user to be able
          // to submit an enclosing form on "Enter".
          collapse();
        }
        return;

      // On Spacebar.
      case 32:
        event.preventDefault();
        return onToggleButtonClick();

      // On "Up" arrow.
      case 38:
        // Collapse the calendar (if expanded).
        if (isExpanded()) {
          event.preventDefault();
          collapse();
        }
        return;

      // On "Down" arrow.
      case 40:
        event.preventDefault();
        // Expand the calendar (if collapsed).
        if (isExpanded()) {
          focusCalendar();
        } else {
          expand().then(focusCalendar);
        }
        return;
    }
  }, [onKeyDown, isExpanded, collapse, expand, focusCalendar, onToggleButtonClick]);
  var onInputChange = (0, _react.useCallback)(function (event) {
    // Extract `value` from the argument
    // of this `onChange` listener
    // (for convenience)

    var newTextValue = event;
    if (event.target !== undefined) {
      newTextValue = event.target.value;
    }
    newTextValue = newTextValue.trim();

    // When the date is erased, reset it.
    if (!newTextValue) {
      // Call `onChange` only if `value` did actually change from non-`undefined` to `undefined`.
      if (value) {
        onChange(undefined);
      }
      // `textValue` is set to an empty string instead of just `undefined` here
      // because there's a `textValue !== undefined` condition when passing
      // `value` property to `<TextInput/>`.
      // So an empty string has a different behavior than just `undefined`:
      // * Setting `textValue` to `undefined` simply discards any custom `textValue`
      //   and uses the formatted `value` instead of it.
      // * Setting `textValue` to an empty string specifically clears the `<input/>` field.
      return setTextValue('');
    }
    newTextValue = (0, _transformDateInputAccordingToTemplate["default"])(newTextValue, format);

    // const selectedDate = parseDate(newTextValue, format, noon, utc)
    var selectedDate = (0, _parseDate["default"])(newTextValue, format, utc);

    // If the date input is unparseable,
    // then don't change the selected date.
    if (selectedDate) {
      // If the date being input is one of the disabled days,
      // then don't change the selected date.
      if (!_reactDayPicker.ModifiersUtils.dayMatchesModifier(selectedDate, disabledDays)) {
        // Call `onChange` only if `value` did actually change
        if (!value || value.getTime() !== selectedDate.getTime()) {
          onChange(selectedDate);
        }
      }
    }
    setTextValue(newTextValue);
  }, [value, onChange, format,
  // noon,
  utc, disabledDays]);
  var onDayClick = (0, _react.useCallback)(function (selectedDay, _ref3) {
    var disabled = _ref3.disabled;
    // If the day clicked is disabled then do nothing.
    if (disabled) {
      return;
    }

    // Fixes the time being `12:00` on the selected day.
    // https://github.com/gpbl/react-day-picker/issues/473
    // Sets it to be proper time `00:00`.
    //
    // They set the time of `selectedDay` to `12:00` in the current time zone.
    // They intended those extra 12 hours to make things less weird with timezone conversions.
    // But it doesn't work in all cases and is a really lame workaround.
    //
    // Maybe they'll change it in `react-day-picker@8`.

    // if (!noon) {
    // Here I strip those 12 hours from the `selectedDay`
    // so the time becomes `00:00` in the user's time zone.
    //
    // (`selectedDay` is the date in the user's time zone)
    // (`selectedDay.getDate()` returns the day in the user's time zone)
    // (`new Date(year, month, day)` creates a date in the user's time zone)
    //
    selectedDay = new Date(selectedDay.getFullYear(), selectedDay.getMonth(), selectedDay.getDate());
    // }

    if (utc) {
      // Converts timezone to UTC while preserving the same time
      selectedDay = (0, _parseDate.getSameDateAndTimeInUtc0TimeZone)(selectedDay);
    }

    // `onChange` fires but the `value`
    // hasn't neccessarily been updated yet.
    //
    // Call `onChange` only if `value` did actually change.
    //
    if (!value || value.getTime() !== selectedDay.getTime()) {
      onChange(selectedDay);
    }

    // Hide the calendar
    hasDayJustBeenSelected.current = true;
    collapse();
    hasDayJustBeenSelected.current = false;

    // Focus the `<input/>`.
    // (if not in "input overlay" mode for mobile devices).
    if (getComputedStyle(inputOverlay.current).display === 'none') {
      // `this.focusAfterDaySelected` flag was used to find out the reason
      // why the text input was being focused: if it was being focused
      // after a calendar day was selected, then it didn't expand the calendar.
      // Previously, this component used to expand the calendar on focus.
      // Now it doesn't, so `this.focusAfterDaySelected` flag is no longer used.
      // this.focusAfterDaySelected = true
      input.current.focus();

      // // For some reason in IE 11 `onFocus` on `<input/>` is not called immediately.
      // if (isInternetExplorer()) {
      // 	setTimeout(() => this.focusAfterDaySelected = false, 0)
      // } else {
      // 	this.focusAfterDaySelected = false
      // }
    }
  }, [format, onChange, value,
  // noon,
  utc, collapse]);

  // const onCalendarKeyDown = (event) =>
  // {
  // 	switch (event)
  // 	{
  // 		// The next year is selected on "Up" arrow,
  // 		// so `.preventDefault()` it to prevent page scrolling.
  // 		// https://github.com/gpbl/react-day-picker/issues/273
  // 		case 38:
  // 			event.preventDefault()
  // 			return
  //
  // 		// The previous year is selected on "Down" arrow,
  // 		// so `.preventDefault()` it to prevent page scrolling.
  // 		// https://github.com/gpbl/react-day-picker/issues/273
  // 		case 40:
  // 			event.preventDefault()
  // 			return
  // 	}
  // }

  var onMonthChange = (0, _react.useCallback)(function (month) {
    setMonth(month);
  }, []);
  var preventBlur = (0, _react.useCallback)(function () {
    // A hack for iOS when it collapses
    // the calendar after selecting a year/month.
    // When selecting a year/month and pressing "Done" button
    // iOS triggers `blur` event on the corresponding `<select/>`
    // which in turn causes the calendar to collapse.
    // This workaround prevents that by re-focusing the calendar.
    if (_userHasJustChangedYearOrMonth.current) {
      focusCalendar();
      return true;
    }
  }, [focusCalendar]);
  var onBlur_ = (0, _react.useCallback)(function (event) {
    clearTimeout(blurTimer.current);
    var result = (0, _focus.onBlur)(event, onFocusOut, function () {
      return container.current;
    }, function () {
      return input.current;
    }, preventBlur);
    if (typeof result === 'number') {
      blurTimer.current = result;
    }
  }, [onFocusOut, preventBlur]);
  var onFocusOut = (0, _react.useCallback)(function (event) {
    // `window.rruiCollapseOnFocusOut` can be used
    // for debugging expandable contents.
    if (window.rruiCollapseOnFocusOut !== false) {
      isFocusingOut.current = true;
      collapse();
      isFocusingOut.current = undefined;
    }
    if (onBlur) {
      (0, _reduxForm.onBlurForReduxForm)(onBlur, event, value);
    }
  }, [collapse, onBlur, value]);
  var getContainerNode = (0, _react.useCallback)(function () {
    return container.current;
  }, []);
  var setContainerNode = (0, _react.useCallback)(function (node) {
    return container.current = node;
  }, []);
  var setInputRef = (0, _react.useCallback)(function (inputRef) {
    if (ref) {
      if (typeof ref === 'function') {
        ref(inputRef);
      } else {
        ref.current = inputRef;
      }
    }
    input.current = inputRef;
  }, [input, ref]);
  var dayFormatter = (0, _react.useMemo)(function () {
    if (typeof Intl !== 'undefined') {
      return new Intl.DateTimeFormat(locale, {
        weekday: 'long',
        year: 'numeric',
        month: 'long',
        day: 'numeric'
      });
    }
  }, [locale]);
  var monthFormatter = (0, _react.useMemo)(function () {
    if (typeof Intl !== 'undefined') {
      return new Intl.DateTimeFormat(locale, {
        month: 'long'
      });
    }
  }, [locale]);
  var weekdayFormatter = (0, _react.useMemo)(function () {
    if (typeof Intl !== 'undefined') {
      return new Intl.DateTimeFormat(locale, {
        weekday: 'long'
      });
    }
  }, [locale]);
  var weekdayShortFormatter = (0, _react.useMemo)(function () {
    if (typeof Intl !== 'undefined') {
      return new Intl.DateTimeFormat(locale, {
        weekday: 'short'
      });
    }
  }, [locale]);
  var firstDayOfWeek = (0, _react.useMemo)(function () {
    // Default: country — US, first day of week — Sunday (0).
    return locale && (0, _getFirstDayOfWeek["default"])(locale) || 0;
  }, [locale]);
  var localeUtils = (0, _react.useMemo)(function () {
    return {
      // Fixes calendar day `aria-label` to be a proper one instead of
      // a weird one (`Mon Jan 03 2022`).
      formatDay: function formatDay(date) {
        if (dayFormatter) {
          return dayFormatter.format(date);
        }
        // A generic non-localized date formatter.
        // https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Date/toDateString
        // Same as `date.toString()` but without time.
        return date.toDateString();
      },
      formatMonthTitle: function formatMonthTitle(date) {
        if (monthFormatter) {
          return monthFormatter.format(date);
        }
        // Returns month and year (in English).
        return _reactDayPicker.LocaleUtils.formatMonthTitle(date);
      },
      formatWeekdayShort: function formatWeekdayShort(i) {
        if (weekdayShortFormatter) {
          return weekdayShortFormatter.format((0, _getDateForDayOfWeek["default"])(i));
        }
        // Returns short weekday (in English).
        return _reactDayPicker.LocaleUtils.formatWeekdayShort(i);
      },
      formatWeekdayLong: function formatWeekdayLong(i) {
        if (weekdayFormatter) {
          return weekdayFormatter.format((0, _getDateForDayOfWeek["default"])(i));
        }
        // Returns long weekday (in English).
        return _reactDayPicker.LocaleUtils.formatWeekdayLong(i);
      },
      getFirstDayOfWeek: function getFirstDayOfWeek() {
        return firstDayOfWeek;
      },
      getMonths: function getMonths() {
        var months = [];
        var i = 0;
        while (i < 12) {
          months.push(monthFormatter.format((0, _getDateForMonth["default"])(i)));
          i++;
        }
        return months;
      }
    };
  }, [locale, dayFormatter, monthFormatter, weekdayFormatter, weekdayShortFormatter, firstDayOfWeek]);

  // `<input type="date"/>` renders a browser-specific date picker
  // which can not be turned off using a simple HTML attribute
  // and also date format is not customizable,
  // therefore just using `<input type="text"/>` here

  var captionElement;
  if (selectYearsIntoPast || selectYearsIntoFuture) {
    captionElement = /*#__PURE__*/_react["default"].createElement(_YearMonthSelect["default"], {
      focus: focusCalendar,
      userHasJustChangedYearOrMonth: userHasJustChangedYearOrMonth,
      selectedDay: value,
      onChange: onMonthChange,
      selectYearsIntoPast: selectYearsIntoPast,
      selectYearsIntoFuture: selectYearsIntoFuture
    });
  }
  return /*#__PURE__*/_react["default"].createElement(_WithError["default"], {
    setRef: setContainerNode,
    error: showErrorMessage ? error : undefined,
    onKeyDown: onContainerKeyDown,
    onBlur: onBlur_,
    style: style,
    className: (0, _classnames["default"])(className, 'rrui__date-picker')
  }, /*#__PURE__*/_react["default"].createElement(_TextInputComponent["default"], _extends({}, rest, {
    ref: setInputRef,
    error: error,
    label: label,
    value: textValue !== undefined ? textValue : (0, _formatDate["default"])(value, format, {
      utc: utc
    }),
    onKeyDown: onInputKeyDown,
    onChange: onInputChange,
    onFocus: onInputFocus,
    onClick: expand
  }), /*#__PURE__*/_react["default"].createElement("div", {
    ref: inputOverlay,
    onClick: onToggleButtonClick,
    tabIndex: -1,
    className: "rrui__date-picker__input-overlay"
  }), /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    onClick: onToggleButtonClick,
    tabIndex: buttonAriaLabel ? undefined : -1,
    "aria-haspopup": undefined && 'grid',
    "aria-expanded": isExpanded_ ? true : false,
    "aria-label": buttonAriaLabel,
    className: (0, _classnames["default"])('rrui__button-reset', 'rrui__outline', 'rrui__date-picker__icon', {
      'rrui__date-picker__icon--hidden': !buttonAriaLabel && !icon
    })
  }, typeof icon === 'function' ? icon() : DEFAULT_CALENDAR_ICON()), /*#__PURE__*/_react["default"].createElement(_Expandable["default"], {
    ref: expandable,
    alignment: alignment,
    onExpand: onExpand,
    onExpanded: onExpanded,
    onCollapse: onCollapse,
    onFocusOut: onBlur_,
    getTogglerNode: getContainerNode,
    scrollIntoViewDelay: waitForKeyboardSlideIn ? keyboardSlideInAnimationDuration : undefined
  }, /*#__PURE__*/_react["default"].createElement(_reactDayPicker["default"], {
    ref: calendar,
    month: month,
    onMonthChange: onMonthChange,
    locale: locale,
    localeUtils: localeUtils,
    firstDayOfWeek: firstDayOfWeek,
    onDayClick: onDayClick,
    selectedDays: (0, _ignoreInvalidDateObjects["default"])(value),
    disabledDays: disabledDays,
    captionElement: captionElement,
    className: "rrui__date-picker__calendar"
  }))));
};
DatePicker = /*#__PURE__*/_react["default"].forwardRef(DatePicker);
DatePicker.propTypes = {
  // An optional label placed on top of the input field
  label: _propTypes["default"].string,
  // Expandable calendar alignment.
  // Is "left" by default.
  alignment: _propTypes["default"].string,
  // A "BCP47" "language tag".
  // Example: "en-US".
  locale: _propTypes["default"].string,
  // Date format. Only supports `dd`, `mm`, `yy` and `yyyy` for now.
  // Can support custom localized formats, perhaps, when `date-fns@2` is released.
  // (is US `mm/dd/yyyy` by default)
  format: _propTypes["default"].string.isRequired,
  // format : PropTypes.oneOfType([PropTypes.string, PropTypes.object]).isRequired,

  // Internationalization
  // locale : PropTypes.string,

  // The Date `value`
  value: _propTypes["default"].instanceOf(Date),
  // Writes new `value`.
  // The `value` is in the user's time zone and the time is `00:00`.
  onChange: _propTypes["default"].func.isRequired,
  // Is called when the date picker is either collapsed or expanded
  onToggle: _propTypes["default"].func,
  // Is called when the input is focused
  onFocus: _propTypes["default"].func,
  // Is called when the input is blurred.
  // This `onBlur` interceptor is a workaround for `redux-form`,
  // so that it gets the parsed `value` in its `onBlur` handler,
  // not the formatted text.
  onBlur: _propTypes["default"].func,
  // Set to `true` to mark the field as required
  required: _propTypes["default"].bool,
  // Indicates that the input is invalid.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  // Set to `false` to not show error message.
  showErrorMessage: _propTypes["default"].bool,
  // HTML `<input/>` `name` attribute
  name: _propTypes["default"].string,
  // `react-day-picker`'s `disabledDays`.
  // http://react-day-picker.js.org/examples/disabled
  disabledDays: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].array]),
  // How much years back can a user navigate using the year `<select/>`
  selectYearsIntoPast: _propTypes["default"].number.isRequired,
  // How much years forward can a user navigate using the year `<select/>`
  selectYearsIntoFuture: _propTypes["default"].number.isRequired,
  // A `date`` from which the initially shown month of the calendar will be derived
  // when no `value` is selected. Is the current month by default.
  initialCalendarDate: _propTypes["default"].instanceOf(Date),
  // Whether dates being selected should be in UTC+0 timezone.
  // (is `false` by default)
  utc: _propTypes["default"].bool.isRequired,
  // // Whether to set time to 12:00 for dates being selected.
  // // (is `true` by default)
  // noon : PropTypes.bool.isRequired,

  // The calendar icon.
  icon: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].bool]),
  // `aria-label` attribute for the toggle calendar button.
  buttonAriaLabel: _propTypes["default"].string,
  waitForKeyboardSlideIn: _propTypes["default"].bool.isRequired,
  keyboardSlideInAnimationDuration: _propTypes["default"].number.isRequired,
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object
};
DatePicker.defaultProps = {
  alignment: 'left',
  // Default US format
  format: 'mm/dd/yyyy',
  // Show `error` (if passed).
  showErrorMessage: true,
  // Whether dates being selected should be in UTC+0 timezone
  utc: true,
  // // Whether to set time to 12:00 for dates being selected
  // noon : false,

  // A sensible default.
  selectYearsIntoPast: 100,
  selectYearsIntoFuture: 100,
  waitForKeyboardSlideIn: true,
  keyboardSlideInAnimationDuration: 300
};
var _default = DatePicker;
exports["default"] = _default;
var iconStyle = {
  width: '100%',
  height: '100%',
  fill: 'currentColor'
};

// Doesn't work.
// https://github.com/gpbl/react-day-picker/issues/841
//
// classNames={ REACT_DAY_PICKER_CLASS_NAMES }
//
// // Default `react-day-picker` CSS class names.
// // Should have been exported from `react-day-picker`.
// // https://github.com/gpbl/react-day-picker/blob/master/src/classNames.js
// // Can change in future versions of `react-day-picker`.
// const REACT_DAY_PICKER_DEFAULT_CLASS_NAMES = {
// 	container: 'DayPicker',
// 	wrapper: 'DayPicker-wrapper',
// 	interactionDisabled: 'DayPicker--interactionDisabled',
// 	months: 'DayPicker-Months',
// 	month: 'DayPicker-Month',
// 	navBar: 'DayPicker-NavBar',
// 	navButtonPrev: 'DayPicker-NavButton DayPicker-NavButton--prev',
// 	navButtonNext: 'DayPicker-NavButton DayPicker-NavButton--next',
// 	navButtonInteractionDisabled: 'DayPicker-NavButton--interactionDisabled',
// 	caption: 'DayPicker-Caption',
// 	weekdays: 'DayPicker-Weekdays',
// 	weekdaysRow: 'DayPicker-WeekdaysRow',
// 	weekday: 'DayPicker-Weekday',
// 	body: 'DayPicker-Body',
// 	week: 'DayPicker-Week',
// 	weekNumber: 'DayPicker-WeekNumber',
// 	day: 'DayPicker-Day',
// 	footer: 'DayPicker-Footer',
// 	todayButton: 'DayPicker-TodayButton',
// 	// default modifiers
// 	today: 'today',
// 	selected: 'selected',
// 	disabled: 'disabled',
// 	outside: 'outside',
// }
//
// const REACT_DAY_PICKER_CLASS_NAMES = {
// 	...REACT_DAY_PICKER_DEFAULT_CLASS_NAMES,
// 	/* `.DayPicker-wrapper` is a `<div/>` wrapping the calendar.
// 	   It gets focused upon expanding which causes an outline.
// 	   That outline can be safely removed because it doesn't aid accesiblity. */
// 	wrapper: REACT_DAY_PICKER_DEFAULT_CLASS_NAMES.wrapper + ' rrui__outline',
// 	/* Calendar days have `background-color` on `:focus`.
// 	   Therefore their `outline` can be safely removed. */
// 	day: REACT_DAY_PICKER_DEFAULT_CLASS_NAMES.day + ' rrui__outline',
// 	/* Previous/Next month buttons have `background-color` on `:focus`.
// 	   Therefore their `outline` can be safely removed. */
// 	navButtonPrev: REACT_DAY_PICKER_DEFAULT_CLASS_NAMES.navButtonPrev + ' rrui__outline',
// 	navButtonNext: REACT_DAY_PICKER_DEFAULT_CLASS_NAMES.navButtonNext + ' rrui__outline'
// }

// Default calendar icon
var DEFAULT_CALENDAR_ICON = function DEFAULT_CALENDAR_ICON() {
  return /*#__PURE__*/_react["default"].createElement("svg", {
    style: iconStyle,
    viewBox: "0 0 32 32"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: " M2 2 L10 2 L10 10 L2 10z M12 2 L20 2 L20 10 L12 10z M22 2 L30 2 L30 10 L22 10z M2 12 L10 12 L10 20 L2 20z M12 12 L20 12 L20 20 L12 20z M22 12 L30 12 L30 20 L22 20z M2 22 L10 22 L10 30 L2 30z M12 22 L20 22 L20 30 L12 30z M22 22 L30 22 L30 30 L22 30z "
  }));
};
//# sourceMappingURL=DatePicker.js.map