"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CanDrop = CanDrop;
exports.DragAndDrop = DragAndDrop;
exports.Files = exports.File = exports.FILES = exports.FILE = exports.DropFiles = void 0;
exports.getFilesFromEvent = getFilesFromEvent;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactCreateRef = _interopRequireDefault(require("react-create-ref"));
var _isFileAccepted = _interopRequireDefault(require("./utility/isFileAccepted"));
var _excluded = ["onDrop", "setDraggedOver", "multiple", "ref_"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var DropFiles_ = /*#__PURE__*/function (_React$Component) {
  _inherits(DropFiles_, _React$Component);
  var _super = _createSuper(DropFiles_);
  function DropFiles_() {
    var _this;
    _classCallCheck(this, DropFiles_);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    // state = {
    // 	isDragging: false
    // }
    _defineProperty(_assertThisInitialized(_this), "node", (0, _reactCreateRef["default"])());
    // Copied from:
    // https://github.com/react-dropzone/react-dropzone/blob/master/src/index.js
    _defineProperty(_assertThisInitialized(_this), "dragTargets", []);
    _defineProperty(_assertThisInitialized(_this), "setRef", function (ref) {
      _this.node.current = ref;
      // A hack for providing `.focus()` method on `<DropFileUpload/>`.
      var ref_ = _this.props.ref_;
      if (ref_) {
        ref_.current = ref;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "setDraggedOver", function (draggedOver) {
      var setDraggedOver = _this.props.setDraggedOver;
      if (setDraggedOver) {
        setDraggedOver(draggedOver);
      }
    });
    // Must be `preventDefault`-ed for some weird reasons.
    _defineProperty(_assertThisInitialized(_this), "onDragOver", function (event) {
      event.preventDefault();
      event.stopPropagation();
    });
    // `event` is always triggered when gragging from another window to the browser window.
    _defineProperty(_assertThisInitialized(_this), "onDragEnter", function (event) {
      event.preventDefault();
      event.stopPropagation();

      // Copied from:
      // https://github.com/react-dropzone/react-dropzone/blob/master/src/index.js
      // Count the dropzone and any children that are entered.
      if (_this.dragTargets.indexOf(event.target) === -1) {
        _this.dragTargets.push(event.target);
      }

      // `event.dataTransfer.files` are only accessible on "drop" event.
      // `event.dataTransfer.items` are only accessible in Chrome and FireFox while dragging.
      // https://developer.mozilla.org/en-US/docs/Web/API/DataTransfer/items
      if (isDraggingFiles(event)) {
        // Filtering dragged files by `isFileAccepted`.
        // Only MIME-types are available during the "drag" stage,
        // not file extensions. And won't work in IE11.
        // // IE11 does not support dataTransfer.items
        // if (event.dataTransfer.items) {
        // 	// Only MIME-types are available for `isFileAccepted`
        // 	// filtering during the "drag" stage, not file extensions.
        // 	// `.some` is supported starting from IE 9.
        // 	const areAnyFilesAccepted = Array.prototype.some.call(
        // 		event.dataTransfer.items,
        // 		this.isFileAccepted
        // 	)
        // 	if (!areAnyFilesAccepted) {
        // 		return
        // 	}
        // }
        _this.setDraggedOver(true);
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onDragLeave", function (event) {
      event.preventDefault();
      event.stopPropagation();

      // Copied from:
      // https://github.com/react-dropzone/react-dropzone/blob/master/src/index.js
      // Only deactivate once the dropzone and all children have been left.
      _this.dragTargets = _this.dragTargets.filter(function (_) {
        return _ !== event.target && _this.node.current.contains(_);
      });
      if (_this.dragTargets.length > 0) {
        return;
      }
      _this.setDraggedOver(false);
    });
    _defineProperty(_assertThisInitialized(_this), "onDrop", function (event) {
      var _this$props = _this.props,
        onDrop = _this$props.onDrop,
        multiple = _this$props.multiple,
        accept = _this$props.accept;
      event.preventDefault();
      event.stopPropagation();

      // Reset.
      _this.dragTargets = [];
      _this.setDraggedOver(false);
      var files = getFilesFromEvent(event); //.filter(this.isFileAccepted)
      if (files.length > 0) {
        if (multiple) {
          onDrop(files, {
            acceptedFiles: accept ? files.filter(_this.isFileAccepted) : files,
            rejectedFiles: accept ? files.filter(function (_) {
              return !_this.isFileAccepted(_);
            }) : []
          });
        } else {
          // If multiple files have been dropped to a non-multiple drop zone
          // then reduce the files list to just the first file.
          onDrop(files[0], {
            isAccepted: _this.isFileAccepted(files[0])
          });
        }
        // Not clear why would it be called.
        // MDN says it's a "no-op".
        // https://developer.mozilla.org/en-US/docs/Web/API/DataTransferItemList/clear
        // event.dataTransfer.clearData()
      }
    });
    _defineProperty(_assertThisInitialized(_this), "isFileAccepted", function (file) {
      var accept = _this.props.accept;
      if (accept) {
        // Firefox versions prior to 53 return a bogus MIME type for every file drag, so dragovers with
        // that MIME type will always be accepted
        if (file.type === 'application/x-moz-file') {
          return true;
        }
        return (0, _isFileAccepted["default"])(file, accept);
      }
      return true;
    });
    return _this;
  }
  _createClass(DropFiles_, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var div = this.node.current;
      div.addEventListener('dragenter', this.onDragEnter);
      div.addEventListener('dragleave', this.onDragLeave);
      div.addEventListener('dragover', this.onDragOver);
      div.addEventListener('drop', this.onDrop);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var div = this.node.current;
      div.removeEventListener('dragenter', this.onDragEnter);
      div.removeEventListener('dragleave', this.onDragLeave);
      div.removeEventListener('dragover', this.onDragOver);
      div.removeEventListener('drop', this.onDrop);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        onDrop = _this$props2.onDrop,
        setDraggedOver = _this$props2.setDraggedOver,
        multiple = _this$props2.multiple,
        ref_ = _this$props2.ref_,
        rest = _objectWithoutProperties(_this$props2, _excluded);
      return /*#__PURE__*/_react["default"].createElement('div', _objectSpread({
        ref: this.setRef
      }, rest));
    }
  }]);
  return DropFiles_;
}(_react["default"].Component); // A hack for providing `.focus()` method on `<DropFileUpload/>`.
_defineProperty(DropFiles_, "propTypes", {
  // Will be called with `true` when the drop zone is dragged over.
  // (and with `false` when it's no longer dragged over)
  setDraggedOver: _propTypes["default"].func,
  // Will be called on file(s) drop.
  // The argument will be the single file when `multiple` is `false` (default)
  // or the array of files when `multiple` is `true`.
  onDrop: _propTypes["default"].func.isRequired,
  // Set to `true` for multi-file drop.
  multiple: _propTypes["default"].bool,
  // Can be used to restrict the file MIME-types or extensions available for selection.
  // https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input/file#attr-accept
  accept: _propTypes["default"].string,
  // A hack for `React.forwardRef()`.
  // Could be rewritten in "hooks" instead.
  // A hack for providing `.focus()` method on `<DropFileUpload/>`.
  ref_: _propTypes["default"].object
});
var DropFiles = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  return /*#__PURE__*/_react["default"].createElement(DropFiles_, _extends({
    ref_: ref
  }, props));
});

// Copied from:
// https://github.com/react-dropzone/react-dropzone/blob/master/src/utils/index.js
exports.DropFiles = DropFiles;
function isDraggingFiles(event) {
  // If `event.dataTransfer` is not available then `event.target.files` fallback is used.
  if (!event.dataTransfer) {
    return true;
  }
  // https://developer.mozilla.org/en-US/docs/Web/API/DataTransfer/types
  // https://developer.mozilla.org/en-US/docs/Web/API/HTML_Drag_and_Drop_API/Recommended_drag_types#file
  // `.some` is supported starting from IE 9.
  return Array.prototype.some.call(event.dataTransfer.types, function (type) {
    return type === 'Files' || type === 'application/x-moz-file';
  });
}

// Copied from:
// https://github.com/react-dropzone/react-dropzone/blob/master/src/utils/index.js
function getFilesFromEvent(event) {
  var dataTransferItemsList = [];
  if (event.dataTransfer) {
    var dt = event.dataTransfer;
    // NOTE: Only the 'drop' event has access to DataTransfer.files,
    // otherwise it will always be empty
    if (dt.files && dt.files.length) {
      dataTransferItemsList = dt.files;
    } else if (dt.items && dt.items.length) {
      // During the drag even the dataTransfer.files is null
      // but Chrome implements some drag store, which is accesible via dataTransfer.items
      dataTransferItemsList = dt.items;
    }
  } else if (event.target && event.target.files) {
    dataTransferItemsList = event.target.files;
  }
  // Convert from DataTransferItemsList to the native Array
  return Array.prototype.slice.call(dataTransferItemsList);
}

// // Copied from:
// // https://github.com/react-dropzone/react-dropzone/blob/master/src/utils/index.js
// // Firefox versions prior to 53 return a bogus MIME type for every file drag, so dragovers with
// // that MIME type will always be accepted
// function isFileAccepted(file, accept) {
// 	return this.props.isFileAccepted(file) || (file.type === 'application/x-moz-file' || this.props.isFileTypeAccepted(file))
// }

// Deprecated.
function CanDrop(type, drop) {
  throw new Error('`react-dnd` has been removed from `react-responsive-ui` starting from version `0.14.124` due to being buggy and not supported. `react-dnd` has been replaced with simple native HTML file drag-n-drop. Use `<DropFileUpload/>` and `<DropMultiFileUpload/>` components for file upload instead of `DragAndDrop` and `CanDrop` decorators.');
}

// Deprecated.
function DragAndDrop() {
  throw new Error('`react-dnd` has been removed from `react-responsive-ui` starting from version `0.14.124` due to being buggy and not supported. `react-dnd` has been replaced with simple native HTML file drag-n-drop. `DragAndDrop` decorator is no longer needed and should be removed. Use `<DropFileUpload/>` and `<DropMultiFileUpload/>` components for file upload.');
}

// Deprecated.
// Native file drag'n'drop (single file)
var File = 'File';

// Deprecated.
// Native file drag'n'drop (multiple files)
exports.File = File;
var Files = 'Files';

// Deprecated.
// Native file drag'n'drop (single file)
exports.Files = Files;
var FILE = File;

// Deprecated.
// Native file drag'n'drop (multiple files)
exports.FILE = FILE;
var FILES = Files;
exports.FILES = FILES;
//# sourceMappingURL=DragAndDrop.js.map