"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ExpandableMenu;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactCreateRef = _interopRequireDefault(require("react-create-ref"));
var _ExpandableList = _interopRequireDefault(require("./ExpandableList"));
var _List = _interopRequireDefault(require("./List"));
var _Close = _interopRequireWildcard(require("./Close"));
var _focus = require("./utility/focus");
var _excluded = ["buttonTitle", "disabled", "style", "className", "button", "buttonComponent", "buttonProps", "buttonClassName", "toggleElement", "toggler", "togglerAriaLabel", "togglerAriaHasPopup", "togglerClassName", "children"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ExpandableMenu(props) {
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    isExpanded = _useState2[0],
    setExpanded = _useState2[1];

  // The DOM Element reference is only used to determine
  // whether the focus is "inside" the component or "outside" of it,
  // and also for focusing the `<button/>` when closing expandable menu.
  var buttonRef = (0, _react.useRef)();
  var listRef = (0, _react.useRef)();

  // (legacy) (deprecated)
  // Is used to focus legacy togglers.
  var togglerRef = (0, _react.useRef)();
  var buttonRefExternal = props.buttonRef;
  var setToggleButtonRef = (0, _react.useCallback)(function (instance) {
    buttonRef.current = instance;
    if (buttonRefExternal) {
      if (typeof buttonRefExternal === 'function') {
        buttonRefExternal(instance);
      } else {
        buttonRefExternal.current = instance;
      }
    }
  }, [buttonRefExternal]);
  var focus = (0, _react.useCallback)(function () {
    // `togglerRef` is deprecated.
    (0, _focus.focus)(togglerRef.current || buttonRef.current);
  }, []);

  // Returns a `Promise`.
  var expand = (0, _react.useCallback)(function () {
    return listRef.current.expand();
  }, [listRef]);

  // Returns a `Promise`.
  var collapse = (0, _react.useCallback)(function () {
    return listRef.current.collapse();
  }, [listRef]);

  // Returns a `Promise`.
  var toggle = (0, _react.useCallback)(function () {
    return listRef.current.toggle();
  }, [listRef]);
  var onExpand = (0, _react.useCallback)(function () {
    setExpanded(true);
  }, []);
  var onCollapse = (0, _react.useCallback)(function (_ref) {
    var focusOut = _ref.focusOut;
    if (!focusOut) {
      focus();
    }
    setExpanded(false);
    // // A workaround for Safari (both macOS and iOS) bug: `<button/>`s not getting focus.
    // // https://stackoverflow.com/questions/20359962/jquery-mobile-focusout-event-for-relatedtarget-returns-incorrect-result-in-safar
    // this.cooldown = true
    // this.cooldownTimer = setTimeout(() => this.cooldown = false, 30)
  }, [focus]);
  var onFocusOut = (0, _react.useCallback)(function () {
    // `window.rruiCollapseOnFocusOut` can be used
    // for debugging expandable contents.
    if (window.rruiCollapseOnFocusOut !== false) {
      collapse();
    }
  }, [collapse]);
  var getButtonElement = (0, _react.useCallback)(function () {
    return buttonRef.current;
  }, []);
  var onBlur = (0, _react.useCallback)(function (event) {
    if (listRef.current) {
      listRef.current.onBlur(event);
    }
  }, []);
  var onClick = (0, _react.useCallback)(function (event) {
    // // A workaround for Safari (both macOS and iOS) bug: `<button/>`s not getting focus.
    // // https://stackoverflow.com/questions/20359962/jquery-mobile-focusout-event-for-relatedtarget-returns-incorrect-result-in-safar
    // if (!this.cooldown) {
    toggle();
    // }
  }, [toggle]);
  var onKeyDown = (0, _react.useCallback)(function (event) {
    if (event.defaultPrevented) {
      return;
    }
    if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
      return;
    }
    switch (event.keyCode) {
      // "Up" arrow.
      // Select the previous item (if present).
      case 38:
      // "Down" arrow.
      // Select the next item (if present).
      case 40:
        return listRef.current.onKeyDown(event);

      // "Enter".
      case 13:
        // Submit containing `<form/>`.
        // Expand otherwise.
        expand();
        return event.preventDefault();
    }
  }, [expand]);
  var buttonTitle = props.buttonTitle,
    disabled = props.disabled,
    style = props.style,
    className = props.className,
    button = props.button,
    buttonComponent = props.buttonComponent,
    buttonProps = props.buttonProps,
    buttonClassName = props.buttonClassName,
    toggleElement = props.toggleElement,
    toggler = props.toggler,
    togglerAriaLabel = props.togglerAriaLabel,
    togglerAriaHasPopup = props.togglerAriaHasPopup,
    togglerClassName = props.togglerClassName,
    children = props.children,
    rest = _objectWithoutProperties(props, _excluded);

  // `button` is a legacy property name.
  // `buttonComponent` is a new property name.
  var CustomButtonComponent = buttonComponent || button;
  var menuToggler;
  var menuItems;
  if (CustomButtonComponent || buttonProps || toggleElement || toggler) {
    menuItems = children;
    var DefaultButtonComponent = 'button';
    var defaultButtonComponentClassNames = 'rrui__button-reset' + ' ' + 'rrui__outline';
    var defaultButtonComponentProps = {
      type: 'button'
    };
    var isDefaultButtonComponent = !CustomButtonComponent;
    var ButtonComponent = isDefaultButtonComponent ? 'button' : CustomButtonComponent;
    var buttonComponentChildren = toggleElement || (buttonProps ? buttonProps.children : null) || (toggler ? /*#__PURE__*/_react["default"].createElement(toggler) : null);
    menuToggler = /*#__PURE__*/_react["default"].createElement(ButtonComponent, _extends({
      "aria-haspopup": togglerAriaHasPopup,
      "aria-label": togglerAriaLabel,
      title: buttonTitle,
      disabled: disabled,
      className: (0, _classnames["default"])(togglerClassName, buttonClassName, isDefaultButtonComponent ? defaultButtonComponentClassNames : undefined)
    }, isDefaultButtonComponent ? defaultButtonComponentProps : buttonProps, {
      ref: setToggleButtonRef,
      onClick: onClick,
      onKeyDown: onKeyDown,
      onBlur: onBlur,
      "aria-expanded": isExpanded
    }), buttonComponentChildren);
  } else {
    // Legacy way: the first child was the toggler.
    menuItems = _react["default"].Children.toArray(children);
    menuToggler = menuItems.shift();
    menuToggler = /*#__PURE__*/_react["default"].createElement("div", {
      ref: buttonRef,
      onClick: onClick,
      onKeyDown: onKeyDown,
      onBlur: onBlur
    }, /*#__PURE__*/_react["default"].cloneElement(menuToggler, {
      ref: togglerRef
    }));
  }
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: style,
    className: (0, _classnames["default"])('rrui__menu', className)
  }, menuToggler, /*#__PURE__*/_react["default"].createElement(_ExpandableList["default"], _extends({}, rest, {
    animation: "fade-up",
    ref: listRef,
    "aria-label": props['aria-label'],
    tabbable: false,
    scrollMaxItems: 0,
    onCollapse: onCollapse,
    onExpand: onExpand,
    onFocusOut: onFocusOut,
    getTogglerNode: getButtonElement,
    focusSelectedItem: false,
    className: "rrui__shadow"
  }), menuItems));
}
ExpandableMenu.propTypes = {
  // Component CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object,
  // `aria-label` for the "Close" button
  // (which is an "x" visible in fullscreen mode).
  closeLabel: _propTypes["default"].string,
  // The "x" button icon that closes the `<Select/>`
  // in fullscreen mode on mobile devices.
  closeButtonIcon: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].oneOf([false])]).isRequired,
  // Must accept a `ref`.
  // Receives properties: `onClick`, `onKeyDown`, `onBlur`, `aria-expanded`.
  buttonComponent: _propTypes["default"].elementType,
  // `button` is a legacy property name.
  // `buttonComponent` is a new property name.
  button: _propTypes["default"].elementType,
  buttonProps: _propTypes["default"].object,
  buttonClassName: _propTypes["default"].string,
  toggleElement: _propTypes["default"].node,
  // (deprecated, use `button` component instead)
  toggler: _propTypes["default"].func,
  // (deprecated, use `buttonProps` instead)
  togglerAriaLabel: _propTypes["default"].string,
  // (deprecated, use `buttonProps` instead)
  togglerAriaHasPopup: _propTypes["default"].string,
  // (deprecated, use `buttonProps` instead)
  togglerClassName: _propTypes["default"].string,
  // A `ref` for the toggle button
  buttonRef: _propTypes["default"].object,
  buttonTitle: _propTypes["default"].string,
  alignment: _propTypes["default"].oneOf(['left', 'right']),
  disabled: _propTypes["default"].bool
};
ExpandableMenu.defaultProps = {
  // The "x" button icon that closes the `<Select/>`
  // in fullscreen mode on mobile devices.
  closeButtonIcon: _Close.CloseIcon
};
//# sourceMappingURL=ExpandableMenu.js.map