"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _DragAndDrop = require("./DragAndDrop");
var _FileUploadInput = _interopRequireWildcard(require("./FileUploadInput"));
var _WithError = _interopRequireDefault(require("./WithError"));
var _dom = require("./utility/dom");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = _react["default"].PureComponent || _react["default"].Component;
var FileUpload = /*#__PURE__*/function (_PureComponent) {
  _inherits(FileUpload, _PureComponent);
  var _super = _createSuper(FileUpload);
  function FileUpload() {
    var _this;
    _classCallCheck(this, FileUpload);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      draggedOver: false
    });
    _defineProperty(_assertThisInitialized(_this), "onClick", function (event) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        onClick = _this$props.onClick;
      if (disabled) {
        if (event) {
          event.preventDefault();
        }
        return;
      }
      if (onClick) {
        onClick();
      }
      _this.fileInput.click();
    });
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }
      switch (event.keyCode) {
        // "Enter".
        case 13:
        // Spacebar.
        case 32:
          event.preventDefault();
          // Emulate `:active` on key press.
          // setTimeout(() => {
          // 	if (this._isMounted) {
          // 		this.setState({
          // 			isActive: true
          // 		})
          // 	}
          // })
          return _this.onClick();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "setDraggedOver", function (draggedOver) {
      return _this.setState({
        draggedOver: draggedOver
      });
    });
    _defineProperty(_assertThisInitialized(_this), "storeFileInputRef", function (ref) {
      return _this.fileInput = ref;
    });
    _defineProperty(_assertThisInitialized(_this), "onFileInputChange", function (value) {
      var _this$props2 = _this.props,
        multiple = _this$props2.multiple,
        onChange = _this$props2.onChange;
      if (multiple) {
        onChange(value, {
          acceptedFiles: value,
          rejectedFiles: []
        });
      } else {
        onChange(value, {
          isAccepted: true
        });
      }
    });
    return _this;
  }
  _createClass(FileUpload, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        ref_ = _this$props3.ref_,
        required = _this$props3.required,
        error = _this$props3.error,
        showErrorMessage = _this$props3.showErrorMessage,
        disabled = _this$props3.disabled,
        tabIndex = _this$props3.tabIndex,
        onChange = _this$props3.onChange,
        clickable = _this$props3.clickable,
        multiple = _this$props3.multiple,
        accept = _this$props3.accept,
        ext = _this$props3.ext,
        style = _this$props3.style,
        draggedOverClassName = _this$props3.draggedOverClassName,
        className = _this$props3.className,
        children = _this$props3.children;
      var draggedOver = this.state.draggedOver;
      var _accept = accept || ext && (0, _FileUploadInput.getAcceptFromExt)(ext);
      var dropFilesElementProps;
      if (clickable) {
        dropFilesElementProps = {
          role: 'button',
          tabIndex: tabIndex === undefined ? 0 : tabIndex,
          onClick: this.onClick,
          onKeyDown: this.onKeyDown
        };
      }
      return /*#__PURE__*/_react["default"].createElement(_WithError["default"], {
        error: showErrorMessage ? error : undefined,
        style: style,
        className: (0, _classnames["default"])('rrui__file-upload', className, draggedOver && draggedOverClassName)
      }, /*#__PURE__*/_react["default"].createElement(_FileUploadInput["default"], {
        ref: this.storeFileInputRef,
        multiple: multiple,
        onChange: this.onFileInputChange,
        error: error,
        required: required,
        disabled: disabled,
        accept: _accept,
        "aria-label": this.props['aria-label']
      }), /*#__PURE__*/_react["default"].createElement(_DragAndDrop.DropFiles, _extends({
        ref: ref_
      }, dropFilesElementProps, {
        "aria-label": this.props['aria-label'],
        accept: _accept,
        multiple: multiple,
        onDrop: onChange,
        setDraggedOver: this.setDraggedOver,
        className: (0, _classnames["default"])( /* Developers should define `:focus` styles for `<FileUpload/>`s. */
        'rrui__outline', 'rrui__file-upload__area', {
          'rrui__file-upload__area--clickable': clickable,
          'rrui__file-upload__area--disabled': disabled,
          'rrui__file-upload__area--invalid': error,
          'rrui__file-upload__area--dragged-over': draggedOver
        })
      }), children));
    }
  }]);
  return FileUpload;
}(PureComponent); // A hack for providing `.focus()` method on `<DropFileUpload/>`.
_defineProperty(FileUpload, "propTypes", {
  // On file(s) chosen.
  onChange: _propTypes["default"].func,
  // Whether the area should be focusable/clickable.
  clickable: _propTypes["default"].bool,
  // Allows choosing multiple files if `true`.
  multiple: _propTypes["default"].bool,
  // Can be used to restrict the file MIME-types or extensions available for selection.
  // https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input/file#attr-accept
  accept: _propTypes["default"].string,
  // Will be transformed to `accept`.
  ext: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].string), _propTypes["default"].string]),
  // Disables the file input.
  disabled: _propTypes["default"].bool,
  // `onClick` handler.
  onClick: _propTypes["default"].func,
  // Whether choosing a file (or files) is required.
  required: _propTypes["default"].bool,
  // Indicates that the input is invalid.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  showErrorMessage: _propTypes["default"].bool,
  tabIndex: _propTypes["default"].number,
  // The contents of the file drop area.
  // Example: "Click here to choose a file".
  children: _propTypes["default"].node,
  // CSS class when dragged over.
  draggedOverClassName: _propTypes["default"].string,
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object,
  // Deprecated.
  // Rewrite this component in hooks instead.
  // A hack for `React.forwardRef()`.
  // Could be rewritten in "hooks" instead.
  // A hack for providing `.focus()` method on `<DropFileUpload/>`.
  ref_: _propTypes["default"].object
});
_defineProperty(FileUpload, "defaultProps", {
  clickable: true,
  showErrorMessage: true
});
var _default = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  return /*#__PURE__*/_react["default"].createElement(FileUpload, _extends({
    ref_: ref
  }, props));
});
exports["default"] = _default;
//# sourceMappingURL=FileUpload.js.map