"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ModalContext = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactModal = _interopRequireDefault(require("react-modal"));
var _createReactContext = _interopRequireDefault(require("create-react-context"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _requestAnimationFrameTimeout = require("request-animation-frame-timeout");
var _Form = _interopRequireDefault(require("./Form"));
var _Button = _interopRequireDefault(require("./Button"));
var _Close = _interopRequireWildcard(require("./Close"));
var _excluded = ["wait", "busy", "fullscreen", "isOpen", "closeTimeout", "ariaLabel", "contentLabel", "title", "closeLabel", "ariaHideApp", "closeButtonIcon", "actions", "unmount", "style", "className", "overlayClassName", "children"],
  _excluded2 = ["closeButton", "className", "children"],
  _excluded3 = ["closeButton", "className", "children"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // For some weird reason, in Chrome, `setTimeout()` would lag up to a second (or more) behind.
// Turns out, Chrome developers have deprecated `setTimeout()` API entirely without asking anyone.
// Replacing `setTimeout()` with `requestAnimationFrame()` can work around that Chrome bug.
// https://github.com/bvaughn/react-virtualized/issues/722
var ModalContext = (0, _createReactContext["default"])();

// Make sure to add `.rrui__fixed-full-width` CSS class
// to all full-width `position: fixed` elements.
// Such elements must not be `width: 100%`
// but rather `width: auto` or `left: 0; right: 0;`.
exports.ModalContext = ModalContext;
var Modal = /*#__PURE__*/function (_Component) {
  _inherits(Modal, _Component);
  var _super = _createSuper(Modal);
  function Modal(props) {
    var _this;
    _classCallCheck(this, Modal);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "storeContentInstance", function (ref) {
      return _this.content = ref;
    });
    _defineProperty(_assertThisInitialized(_this), "registerForm", function () {
      // Using a counter instead of a boolean here
      // because a new form may be mounted before the old one is unmounted.
      // (React reconciliation algorythm implementation details)
      _this.setState(function (_ref) {
        var form = _ref.form;
        return {
          form: form + 1
        };
      });
    });
    _defineProperty(_assertThisInitialized(_this), "unregisterForm", function () {
      if (_this.unmounted) {
        return;
      }

      // Using a counter instead of a boolean here
      // because a new form may be mounted before the old one is unmounted.
      // (React reconciliation algorythm implementation details)
      _this.setState(function (_ref2) {
        var form = _ref2.form;
        return {
          form: form - 1
        };
      });
    });
    _defineProperty(_assertThisInitialized(_this), "on_request_close", function (event) {
      var closeLabel = _this.props.closeLabel;
      var form = _this.state.form;

      // If the modal has an explicit "Cancel" button,
      // then allow closing it by hitting "Escape" key,
      // but don't close it on a click outside.
      // (because a user wouldn't want to loose form data due to a misclick)
      if (closeLabel && form && event && event.type !== 'keydown') {
        _this.indicate_cannot_close();
        // Focus on `<ReactModal/>` element.
        return _this.content.focus();
      }
      _this.closeIfNotBusy();
    });
    _defineProperty(_assertThisInitialized(_this), "closeIfNotBusy", function () {
      var _this$props = _this.props,
        wait = _this$props.wait,
        busy = _this$props.busy,
        close = _this$props.close,
        closeTimeout = _this$props.closeTimeout;

      // For weird messed development mode cases
      if (_this.unmounted) {
        return;
      }

      // Don't close the modal if it's busy
      if (wait || busy) {
        return _this.indicate_cannot_close();
      }

      // Abruptly end "couldn't close" animation to make room for closing animation
      _this.setState({
        could_not_close_because_busy: false
      });

      // Close the modal
      if (close) {
        close();
      }
    });
    _defineProperty(_assertThisInitialized(_this), "on_after_open", function () {
      var afterOpen = _this.props.afterOpen;
      _this.adjust_scrollbar_after_open();
      if (afterOpen) {
        afterOpen();
      }
    });
    // Restores original `document` scrollbar
    // and resets the modal content (e.g. a form)
    _defineProperty(_assertThisInitialized(_this), "on_after_close", function () {
      var _this$props2 = _this.props,
        afterClose = _this$props2.afterClose,
        reset = _this$props2.reset;
      if (reset) {
        reset();
      }
      if (afterClose) {
        afterClose();
      }
      _this.adjust_scrollbar_after_close();
    });
    _this.state = {
      // Using a counter instead of a boolean here
      // because a new form may be mounted before the old one is unmounted.
      // (React reconciliation algorythm implementation details)
      form: 0,
      context: {
        closeLabel: _this.props.closeLabel,
        closeIfNotBusy: _this.closeIfNotBusy,
        registerForm: _this.registerForm,
        unregisterForm: _this.unregisterForm
      }
    };
    return _this;
  }
  _createClass(Modal, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this$props3 = this.props,
        unmount = _this$props3.unmount,
        isOpen = _this$props3.isOpen;

      // If prevent `<Modal/>` contents
      // from being unmounted upon close.
      if (!unmount) {
        // If has been opened.
        if (!prevProps.isOpen && isOpen) {
          this.on_after_open();
        }
        // If has been closed.
        else if (prevProps.isOpen && !isOpen) {
          this.on_after_close();
          this.reset_content_scroll();
        }
      }
    }

    // A modal itself umounts only when the user leaves a page,
    // so in a "Single Page Application", for example,
    // if this was a regular popup and a user could still navigate
    // away via a hyperlink then this code becomes neccessary.
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var isOpen = this.props.isOpen;
      this.unmounted = true;

      // If the modal is still open
      // while a user navigates away
      // then "close" it properly
      // (restore the document scrollbars, etc).
      if (isOpen) {
        this.on_after_close();
      }
      (0, _requestAnimationFrameTimeout.clearTimeout)(this.could_not_close_because_busy_animation_timeout);
      this.could_not_close_because_busy_animation_timeout = undefined;
    }
  }, {
    key: "getAppElement",
    value: function getAppElement() {
      var _this$props4 = this.props,
        appElement = _this$props4.appElement,
        appElementId = _this$props4.appElementId;
      if (appElementId && typeof window !== 'undefined') {
        return document.getElementById(appElementId);
      }
      return appElement;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        wait = _this$props5.wait,
        busy = _this$props5.busy,
        fullscreen = _this$props5.fullscreen,
        isOpen = _this$props5.isOpen,
        closeTimeout = _this$props5.closeTimeout,
        ariaLabel = _this$props5.ariaLabel,
        contentLabel = _this$props5.contentLabel,
        title = _this$props5.title,
        closeLabel = _this$props5.closeLabel,
        ariaHideApp = _this$props5.ariaHideApp,
        closeButtonIcon = _this$props5.closeButtonIcon,
        actions = _this$props5.actions,
        unmount = _this$props5.unmount,
        style = _this$props5.style,
        className = _this$props5.className,
        overlayClassName = _this$props5.overlayClassName,
        children = _this$props5.children,
        rest = _objectWithoutProperties(_this$props5, _excluded);
      var _this$state = this.state,
        could_not_close_because_busy = _this$state.could_not_close_because_busy,
        form = _this$state.form;

      // `aria-modal` was added in WAI-ARIA 1.1 and is not supported yet.
      // https://www.levelaccess.com/differences-aria-1-0-1-1-deprecations-additions/

      return /*#__PURE__*/_react["default"].createElement(_reactModal["default"], _extends({}, rest, {
        isOpen: unmount ? isOpen : true,
        onAfterOpen: unmount ? this.on_after_open : undefined,
        onRequestClose: this.on_request_close,
        closeTimeoutMS: closeTimeout,
        contentLabel: this.props['aria-label'] || ariaLabel || contentLabel,
        ariaHideApp: this.getAppElement() || globalAppElement ? ariaHideApp : false,
        appElement: this.getAppElement(),
        style: react_modal_style,
        overlayClassName: (0, _classnames["default"])('rrui__modal__overlay', {
          'rrui__modal__overlay--busy': wait || busy,
          'rrui__modal__overlay--fullscreen': fullscreen,
          'rrui__modal__overlay--hidden': !unmount && !isOpen
        }, overlayClassName),
        className: (0, _classnames["default"])(
        // A `<Modal/>` gets focused when it gets open
        // and this causes an outline around it.
        // This outline doesn't relate that much to actual
        // accessibilty so it can be muted safely.
        'rrui__outline', 'rrui__modal__container', {
          'rrui__modal__container--fullscreen': fullscreen
        })
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('rrui__modal__vertical-margin', 'rrui__modal__vertical-margin--top', {
          // CSS selector performance optimization
          'rrui__modal__vertical-margin--fullscreen': fullscreen
        }),
        onClick: this.on_request_close
      }), /*#__PURE__*/_react["default"].createElement(ModalContext.Provider, {
        value: this.state.context
      }, /*#__PURE__*/_react["default"].createElement(ModalContentWrapper, {
        ref: this.storeContentInstance,
        closeLabel: closeLabel,
        closeButtonIcon: closeButtonIcon,
        close: this.closeIfNotBusy,
        style: style,
        className: className,
        fullscreen: fullscreen,
        could_not_close_because_busy: could_not_close_because_busy,
        containsForm: form > 0,
        wait: wait || busy,
        reset: this.on_after_close
      }, children)), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('rrui__modal__vertical-margin', 'rrui__modal__vertical-margin--bottom', {
          // CSS selector performance optimization
          'rrui__modal__vertical-margin--fullscreen': fullscreen
        }),
        onClick: this.on_request_close
      }));
    }
  }, {
    key: "indicate_cannot_close",
    value:
    // Play "cannot close" animation on the modal
    function indicate_cannot_close() {
      var _this2 = this;
      var could_not_close_because_busy_animation_duration = this.props.could_not_close_because_busy_animation_duration;
      var could_not_close_because_busy = this.state.could_not_close_because_busy;
      if (!could_not_close_because_busy) {
        this.could_not_close_because_busy_animation_timeout = (0, _requestAnimationFrameTimeout.setTimeout)(function () {
          _this2.could_not_close_because_busy_animation_timeout = undefined;
          _this2.setState({
            could_not_close_because_busy: false
          });
        },
        // Give it a bit of extra time to finish the CSS animation
        could_not_close_because_busy_animation_duration * 1.1);
        this.setState({
          could_not_close_because_busy: true
        });
      }
    }
  }, {
    key: "reset_content_scroll",
    value:
    // If the user scrolled on a previously shown react-modal,
    // then reset that previously scrolled position.
    function reset_content_scroll() {
      document.querySelector('.ReactModal__Overlay').scrollTop = 0;
    }

    // Hides the main (body) scrollbar upon showing a modal
    // and also adjusts the width of all "full-width" elements
    // so that they don't expand no that the scrollbar is absent.
    //
    // This doesn't account for window resizes
    // but since my body is always `overflow: visible` (a good practice)
    // there's no difference and it should work in any scenario.
    //
  }, {
    key: "adjust_scrollbar_after_open",
    value: function adjust_scrollbar_after_open() {
      // A dummy `<div/>` to measure
      // the difference in width
      // needed for the "full-width" elements
      // after the main (body) scrollbar is deliberately hidden.
      var div = document.createElement('div');
      div.style.position = 'fixed';
      div.style.left = 0;
      div.style.right = 0;
      document.body.appendChild(div);

      // Calculate the width of the dummy `<div/>`
      // before the main (body) scrollbar is deliberately hidden.
      var width_before = div.clientWidth;

      // Hide the main (body) scrollbar
      // so that when a user scrolls in an open modal
      // this `scroll` event doesn't go through
      // and scroll the main page.
      document.body.style.overflow = 'hidden';

      // All "full-width" elements will need their
      // width to be adjusted by this amount
      // because of the now-hidden main (body) scrollbar

      // Calculate the width of the dummy `<div/>`
      // after the main (body) scrollbar is deliberately hidden.
      var width_adjustment = div.clientWidth - width_before;
      document.body.removeChild(div);

      // "full-width" elements include `document.body`
      // and all `position: fixed` elements
      // which should be marked with this special CSS class.
      //
      // Make sure to add `.rrui__fixed-full-width` CSS class
      // to all full-width `position: fixed` elements.
      // Such elements must not be `width: 100%`
      // but rather `width: auto` or `left: 0; right: 0;`.
      //
      // Adjusts the width of all "full-width" elements
      // so that they don't expand by the width of the (now absent) scrollbar
      //
      for (var _iterator = _createForOfIteratorHelperLoose(get_full_width_elements()), _step; !(_step = _iterator()).done;) {
        var element = _step.value;
        element.style.marginRight = width_adjustment + 'px';
      }
      this.reset_content_scroll();
    }
  }, {
    key: "adjust_scrollbar_after_close",
    value:
    // Restores original `document` scrollbar.
    function adjust_scrollbar_after_close() {
      var _this$props6 = this.props,
        bodyOverflowX = _this$props6.bodyOverflowX,
        bodyOverflowY = _this$props6.bodyOverflowY;

      // All "full-width" elements will need their
      // width to be restored back to the original value
      // now that the main (body) scrollbar is being restored.

      // "full-width" elements include `document.body`
      // and all `position: fixed` elements
      // which should be marked with this special CSS class.
      //
      // Make sure to add `.rrui__fixed-full-width` CSS class
      // to all full-width `position: fixed` elements.
      // Such elements must not be `width: 100%`
      // but rather `width: auto` or `left: 0; right: 0;`.
      //
      // Adjusts the width of all "full-width" elements back to their original value
      // now that the main (body) scrollbar is being restored.
      //
      for (var _iterator2 = _createForOfIteratorHelperLoose(get_full_width_elements()), _step2; !(_step2 = _iterator2()).done;) {
        var element = _step2.value;
        element.style.marginRight = 0;
      }

      // Restore the main (body) scrollbar.
      document.body.style.overflowX = bodyOverflowX;
      document.body.style.overflowY = bodyOverflowY;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (props.closeLabel !== state.context.closeLabel) {
        return _objectSpread(_objectSpread({}, state), {}, {
          context: _objectSpread(_objectSpread({}, state.context), {}, {
            closeLabel: props.closeLabel
          })
        });
      }
      return null;
    }
  }]);
  return Modal;
}(_react.Component);
_defineProperty(Modal, "propTypes", {
  // If `true` then the modal is shown
  isOpen: _propTypes["default"].bool.isRequired,
  // Closes the modal (must set the `isOpen` flag to `false`)
  close: _propTypes["default"].func.isRequired,
  // A time required for CSS hiding animation to complete
  // (150 milliseconds by default)
  closeTimeout: _propTypes["default"].number.isRequired,
  // Is called after the modal is shown
  afterOpen: _propTypes["default"].func,
  // Is called after the modal is closed
  afterClose: _propTypes["default"].func,
  // Enters fullscreen mode
  fullscreen: _propTypes["default"].bool,
  // Modal content
  children: _propTypes["default"].node,
  // If `wait` is `true` then the modal
  // won't close on click-out or Escape
  // and will show spinner on the overlay.
  wait: _propTypes["default"].bool,
  // (deprecated)
  // (use `wait` instead)
  // If `busy` is `true` then the modal
  // won't close on click-out or Escape
  // and will show spinner on the overlay.
  busy: _propTypes["default"].bool,
  // Resets the modal on close
  // (e.g. could reset edited form fields)
  reset: _propTypes["default"].func,
  // "Cancel" button label.
  // If set, the modal will have a "Cancel" button.
  // (only if `<Form.Actions/>` is found in content)
  closeLabel: _propTypes["default"].string,
  // The default `overflow-x` of the <body/>.
  // Is `auto` by default.
  bodyOverflowX: _propTypes["default"].string.isRequired,
  // The default `overflow-x` of the <body/>.
  // Is `scroll` by default
  // (which is better than `auto`
  //  because the document width won't be jumpy
  //  while navigating the website —
  //  it will be consistent across all pages)
  bodyOverflowY: _propTypes["default"].string.isRequired,
  // Deprecated, use `aria-label` instead.
  ariaLabel: _propTypes["default"].string,
  // Deprecated, use `aria-label` instead.
  contentLabel: _propTypes["default"].string,
  // `aria-hidden` will be set to true on the `appElement`.
  appElement: _propTypes["default"].any,
  appElementId: _propTypes["default"].string,
  // Whether to set `aria-hidden` on the `appElement`.
  // Is `true` inside `react-modal` by default.
  ariaHideApp: _propTypes["default"].bool,
  // An optional close button icon (like a cross).
  // Set to `true` to show the default "cross" icon.
  closeButtonIcon: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].oneOf([true])]),
  // If set to `false` will prevent modal contents
  // from being unmounted when the modal is closed.
  unmount: _propTypes["default"].bool.isRequired,
  // Internal property
  could_not_close_because_busy_animation_duration: _propTypes["default"].number.isRequired,
  // CSS class for overlay (e.g. for fullscreen modal background color)
  overlayClassName: _propTypes["default"].string,
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object
});
_defineProperty(Modal, "defaultProps", {
  isOpen: false,
  bodyOverflowX: 'auto',
  // Prevents document width from jumping due to the
  // vertical scrollbar appearance/disappearance
  bodyOverflowY: 'scroll',
  // when changing this also change
  // your .ReactModal__Overlay and .ReactModal__Content
  // css transition times accordingly
  closeTimeout: 150,
  // ms

  // Modal contents are unmounted when the modal is closed by default
  unmount: true,
  // When changing this also change
  // `.rrui__modal--could-not-close-because-busy`
  // css transition time accordingly
  could_not_close_because_busy_animation_duration: 600 // ms
});
var ModalContentWrapper = /*#__PURE__*/function (_Component2) {
  _inherits(ModalContentWrapper, _Component2);
  var _super2 = _createSuper(ModalContentWrapper);
  function ModalContentWrapper() {
    var _this3;
    _classCallCheck(this, ModalContentWrapper);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this3), "focus", function () {
      return _this3.node.focus();
    });
    _defineProperty(_assertThisInitialized(_this3), "storeNode", function (ref) {
      return _this3.node = ref;
    });
    return _this3;
  }
  _createClass(ModalContentWrapper, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var reset = this.props.reset;
      if (reset) {
        reset();
      }
    }
  }, {
    key: "transformChildren",
    value: function transformChildren() {
      var _this4 = this;
      var _this$props7 = this.props,
        closeLabel = _this$props7.closeLabel,
        closeButtonIcon = _this$props7.closeButtonIcon,
        close = _this$props7.close,
        containsForm = _this$props7.containsForm,
        children = _this$props7.children;
      var closeButtonAdded = false;
      return _react["default"].Children.map(children, function (element) {
        if (closeButtonIcon && !closeButtonAdded) {
          // Workaround for `react-hot-loader`.
          // https://github.com/gaearon/react-hot-loader#checking-element-types
          if (element.type.displayName === 'ModalTitle' || element.type.displayName === 'ModalContent') {
            closeButtonAdded = true;
            return /*#__PURE__*/_react["default"].cloneElement(element, {
              closeButton: _this4.render_close_button()
            });
          }
        }
        if (!closeButtonIcon && closeLabel && !containsForm && element.type === Modal.Actions) {
          return /*#__PURE__*/_react["default"].cloneElement(element, {
            closeButton: /*#__PURE__*/_react["default"].createElement(_Button["default"], {
              className: (0, _classnames["default"])('rrui__modal__close', 'rrui__modal__close--bottom'),
              action: close
            }, closeLabel)
          });
        }
        return element;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props8 = this.props,
        fullscreen = _this$props8.fullscreen,
        className = _this$props8.className,
        style = _this$props8.style,
        could_not_close_because_busy = _this$props8.could_not_close_because_busy;
      return /*#__PURE__*/_react["default"].createElement("section", {
        ref: this.storeNode,
        className: (0, _classnames["default"])('rrui__modal__contents', {
          // CSS selector performance optimization
          'rrui__modal__contents--fullscreen': fullscreen,
          // Strictly speaking it's not `.rrui__modal` but this CSS class name will do
          'rrui__modal--could-not-close-because-busy': could_not_close_because_busy
        }, className),
        style: style
      }, this.transformChildren());
    }
  }, {
    key: "render_close_button",
    value: function render_close_button() {
      var _this$props9 = this.props,
        closeLabel = _this$props9.closeLabel,
        closeButtonIcon = _this$props9.closeButtonIcon,
        close = _this$props9.close,
        wait = _this$props9.wait;
      var CloseButtonIcon = closeButtonIcon === true ? _Close.CloseIcon : closeButtonIcon;
      if (!CloseButtonIcon) {
        return null;
      }
      return /*#__PURE__*/_react["default"].createElement(_Close["default"], {
        onClick: close,
        closeLabel: closeLabel,
        className: (0, _classnames["default"])('rrui__modal__close', 'rrui__modal__close--top', {
          'rrui__modal__close--busy': wait
        })
      }, /*#__PURE__*/_react["default"].createElement(CloseButtonIcon, null));
    }
  }]);
  return ModalContentWrapper;
}(_react.Component);
var react_modal_style = {
  overlay: {
    position: 'fixed',
    left: 0,
    top: 0,
    right: 0,
    bottom: 0,
    // Will show a scrollbar in case of modal content overflowing viewport height
    overflow: 'auto'
  }
};

// "full-width" elements include `document.body`
// and all `position: fixed` elements
// which should be marked with this special CSS class.
//
// Make sure to add `.rrui__fixed-full-width` CSS class
// to all full-width `position: fixed` elements.
// Such elements must not be `width: 100%`
// but rather `width: auto` or `left: 0; right: 0;`.
//
function get_full_width_elements() {
  // `Array.from` requires ES6 polyfill.
  // const full_width_elements = Array.from(document.querySelectorAll('.rrui__fixed-full-width'))
  var full_width_elements = [].slice.call(document.querySelectorAll('.rrui__fixed-full-width'));
  full_width_elements.push(document.body);
  return full_width_elements;
}
var ModalTitle = function ModalTitle(_ref3) {
  var closeButton = _ref3.closeButton,
    className = _ref3.className,
    children = _ref3.children,
    rest = _objectWithoutProperties(_ref3, _excluded2);
  return /*#__PURE__*/_react["default"].createElement("h1", _extends({
    className: (0, _classnames["default"])('rrui__modal__title', className, {
      'rrui__modal__title--close-button': closeButton
    })
  }, rest), closeButton && /*#__PURE__*/_react["default"].createElement("span", {
    className: "rrui__modal__title-itself"
  }, children), !closeButton && children, closeButton);
};

// Workaround for `react-hot-loader`.
// https://github.com/gaearon/react-hot-loader#checking-element-types
ModalTitle.displayName = 'ModalTitle';
var ModalContent = function ModalContent(_ref4) {
  var closeButton = _ref4.closeButton,
    className = _ref4.className,
    children = _ref4.children,
    rest = _objectWithoutProperties(_ref4, _excluded3);
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: (0, _classnames["default"])('rrui__modal__content', className, {
      'rrui__modal__content--close-button': closeButton
    })
  }, rest), closeButton && /*#__PURE__*/_react["default"].createElement("div", {
    className: "rrui__modal__content-itself"
  }, children), !closeButton && children, closeButton);
};

// Workaround for `react-hot-loader`.
// https://github.com/gaearon/react-hot-loader#checking-element-types
ModalContent.displayName = 'ModalContent';
var ModalActions = function ModalActions(_ref5) {
  var closeButton = _ref5.closeButton,
    className = _ref5.className,
    children = _ref5.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(className, 'rrui__modal__actions')
  }, closeButton, children);
};

// Workaround for `react-hot-loader`.
// https://github.com/gaearon/react-hot-loader#checking-element-types
ModalActions.displayName = 'ModalActions';
Modal = (0, _reactLifecyclesCompat.polyfill)(Modal);
Modal.Title = ModalTitle;
Modal.Content = ModalContent;
Modal.Actions = ModalActions;
var globalAppElement;
Modal.setAppElement = function (element) {
  globalAppElement = element;
  _reactModal["default"].setAppElement(element);
};
var _default = Modal;
exports["default"] = _default;
//# sourceMappingURL=Modal.js.map