"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Context = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactCreateRef = _interopRequireDefault(require("react-create-ref"));
var _createReactContext = _interopRequireDefault(require("create-react-context"));
var _PageAndMenu = require("./PageAndMenu");
var _OnFocusOutOrTapOutside = _interopRequireDefault(require("./OnFocusOutOrTapOutside"));
var _excluded = ["anchor", "fullscreen", "getTogglerNode", "className", "children", "menuRef", "onExpand", "onCollapse", "toggleMenu", "registerMenu", "setTogglerCooldown", "expandAnimationDuration"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var Context = (0, _createReactContext["default"])();

// `PureComponent` is only available in React >= 15.3.0.
exports.Context = Context;
var PureComponent = _react["default"].PureComponent || _react["default"].Component;
var ContextAwareSlideoutMenu = /*#__PURE__*/function (_PureComponent) {
  _inherits(ContextAwareSlideoutMenu, _PureComponent);
  var _super = _createSuper(ContextAwareSlideoutMenu);
  function ContextAwareSlideoutMenu() {
    var _this;
    _classCallCheck(this, ContextAwareSlideoutMenu);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "slideOutMenu", (0, _reactCreateRef["default"])());
    _defineProperty(_assertThisInitialized(_this), "show", function () {
      return _this.slideOutMenu.current.show();
    });
    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      return _this.slideOutMenu.current.hide();
    });
    return _this;
  }
  _createClass(ContextAwareSlideoutMenu, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      return /*#__PURE__*/_react["default"].createElement(_PageAndMenu.Context.Consumer, null, function (context) {
        return /*#__PURE__*/_react["default"].createElement(SlideoutMenu, _extends({
          ref: _this2.slideOutMenu
        }, _this2.props, {
          registerMenu: context.registerMenu,
          toggleMenu: context.toggleMenu,
          setTogglerCooldown: context.setTogglerCooldown,
          getTogglerNode: context.getTogglerNode
        }));
      });
    }
  }]);
  return ContextAwareSlideoutMenu;
}(PureComponent); // const ContextAwareSlideoutMenu = (props) => (
// 	<PageAndMenuContext.Consumer>
// 		{context => (
// 			<SlideoutMenu
// 				{...props}
// 				registerMenu={context.registerMenu}
// 				toggleMenu={context.toggleMenu}/>
// 			)
// 		}
// 	</PageAndMenuContext.Consumer>
// )
// export default ContextAwareSlideoutMenu
// Swipeable feature example source code:
// https://github.com/mui-org/material-ui/blob/v1-beta/packages/material-ui/src/SwipeableDrawer/SwipeableDrawer.js
// A slideout menu.
exports["default"] = ContextAwareSlideoutMenu;
var SlideoutMenu = /*#__PURE__*/function (_PureComponent2) {
  _inherits(SlideoutMenu, _PureComponent2);
  var _super2 = _createSuper(SlideoutMenu);
  function SlideoutMenu() {
    var _this3;
    _classCallCheck(this, SlideoutMenu);
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this3), "state", {
      // Initializing it to `false` is required for `if (expand === expanded)`.
      //
      expanded: false
    });
    _defineProperty(_assertThisInitialized(_this3), "container", (0, _reactCreateRef["default"])());
    _defineProperty(_assertThisInitialized(_this3), "onFocusOutRef", (0, _reactCreateRef["default"])());
    _defineProperty(_assertThisInitialized(_this3), "toggle", function (expand) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        onCollapsed = _ref.onCollapsed,
        onExpanded = _ref.onExpanded;
      // This code was copy-pasted from `source/Expandable.js`.

      var _this3$props = _this3.props,
        onCollapse = _this3$props.onCollapse,
        onExpand = _this3$props.onExpand;
      var expanded = _this3.state.expanded;

      // If no `expand` argument provided then just toggle.
      var isExpandedState = expanded && _this3.process !== 'unexpand' || _this3.process === 'expand';
      if (expand === undefined) {
        expand = !isExpandedState;
      }

      // Don't collapse if already collapsed.
      // Don't expand if already expanded.

      if (expand === isExpandedState) {
        return Promise.resolve();
      }

      // if (this.isToggling) {
      // 	return Promise.resolve()
      // }

      if (_this3.cancelProcess) {
        _this3.cancelProcess();
      }
      var cancelled;
      var reset = function reset() {
        _this3.process = undefined;
        _this3.processPhase = undefined;
        _this3.cancelProcess = undefined;
      };
      var nextPhase = function nextPhase(phase) {
        if (!cancelled) {
          _this3.processPhase = phase;
          return true;
        }
      };
      function endProcess() {
        nextPhase();
        reset();
      }
      var phaseCancellers = {};
      function onCancelPhase(phase, handler) {
        phaseCancellers[phase] = handler;
      }
      _this3.cancelProcess = function () {
        if (phaseCancellers[_this3.processPhase]) {
          phaseCancellers[_this3.processPhase]();
        }
        cancelled = true;
        reset();
      };
      if (expand) {
        // Expand.
        _this3.process = 'expand';
        onCancelPhase('scheduleExpand', function () {
          return clearTimeout(_this3.expandTimeout);
        });
        return new Promise(function (resolve) {
          if (!nextPhase('render')) {
            return;
          }
          _this3.setState({
            shouldRender: true
          },
          // Without an artificial delay for some reason the CSS "expand" animation won't play.
          // Perhaps a browser decides to optimize two subsequent renders
          // and doesn't render "pre-expanded" and "expanded" states separately.
          // Even with a 0ms delay it would randomly play/not-play the expand animation.
          function () {
            if (!nextPhase('scheduleExpand')) {
              return;
            }
            if (onExpand) {
              onExpand();
            }
            // Using `requestAnimationFrame()` instead of `setTimeout()`
            // because otherwise there would be a weird and strange delay.
            _this3.expandTimeout = setTimeout(function () {
              if (!nextPhase('expand')) {
                return;
              }
              _this3.expandTimeout = undefined;
              _this3.setState({
                expanded: true
              }, function () {
                if (!nextPhase('expanded')) {
                  return;
                }
                if (onExpanded) {
                  onExpanded();
                }
                if (_this3.onFocusOutRef.current) {
                  _this3.onFocusOutRef.current.listenToTouches();
                }
                endProcess();
                resolve();
              });
            }, 0);
          });
        });
      } else {
        // Un-Expand.
        _this3.process = 'unexpand';
        onCancelPhase('unexpanded', function () {
          return clearTimeout(_this3.waitUnForExpandAnimationTimer);
        });
        nextPhase('unexpand');
        if (_this3.onFocusOutRef.current) {
          _this3.onFocusOutRef.current.stopListeningToTouches();
        }
        if (onCollapse) {
          onCollapse();
        }
        // Set `expanded` to `false` to play the collapse CSS animation.
        // Once that animation is finished remove
        // the contents of the `<Expanded/>` from DOM.
        return new Promise(function (resolve) {
          _this3.setState({
            expanded: false
          }, function () {
            if (!nextPhase('unexpanded')) {
              return;
            }
            if (onCollapsed) {
              onCollapsed();
            }
            var waitForUnExpandAnimation = function waitForUnExpandAnimation() {
              var expandAnimationDuration = _this3.props.expandAnimationDuration;
              return new Promise(function (resolve) {
                _this3.waitUnForExpandAnimationTimer = setTimeout(resolve, expandAnimationDuration * 1.1);
              });
            };
            waitForUnExpandAnimation().then(function () {
              if (!nextPhase('unrender')) {
                return;
              }
              _this3.setState({
                shouldRender: false
              }, endProcess);
            });
            // `resolve()` doesn't wait for `removeFromDOMAfterCollapsed`
            // because other components use it like `.toggle().then(focus)`
            // where it shouldn't wait for the final phases.
            resolve();
          });
        });
      }
    });
    _defineProperty(_assertThisInitialized(_this3), "show", function () {
      var toggleMenu = _this3.props.toggleMenu;
      toggleMenu(true);
    });
    _defineProperty(_assertThisInitialized(_this3), "hide", function () {
      var toggleMenu = _this3.props.toggleMenu;
      toggleMenu(false);
    });
    _defineProperty(_assertThisInitialized(_this3), "onKeyDown", function (event) {
      var toggleMenu = _this3.props.toggleMenu;
      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }
      switch (event.keyCode) {
        // Collapse on "Escape".
        case 27:
          event.preventDefault();
          return toggleMenu(false);
      }
    });
    // Hide the menu on focus out.
    _defineProperty(_assertThisInitialized(_this3), "onFocusOut", function () {
      var _this3$props2 = _this3.props,
        toggleMenu = _this3$props2.toggleMenu,
        setTogglerCooldown = _this3$props2.setTogglerCooldown;
      // `window.rruiCollapseOnFocusOut` can be used
      // for debugging expandable contents.
      if (window.rruiCollapseOnFocusOut !== false) {
        toggleMenu(false);
        setTogglerCooldown();
      }
    });
    _defineProperty(_assertThisInitialized(_this3), "getContainerNode", function () {
      return _this3.container.current;
    });
    return _this3;
  }
  _createClass(SlideoutMenu, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this4 = this;
      var _this$props = this.props,
        registerMenu = _this$props.registerMenu,
        menuRef = _this$props.menuRef;
      this.unregister = registerMenu({
        toggle: this.toggle,
        element: function element() {
          return _this4.container.current;
        },
        menu: function menu() {
          return menuRef ? menuRef.current : _this4.container.current;
        }
      });

      // // Hide on `Back`/`Forward` navigation.
      // window.addEventListener('popstate', this.hide)
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unregister();
      // window.removeEventListener('popstate', this.hide)

      if (this.cancelProcess) {
        this.cancelProcess();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        anchor = _this$props2.anchor,
        fullscreen = _this$props2.fullscreen,
        getTogglerNode = _this$props2.getTogglerNode,
        className = _this$props2.className,
        children = _this$props2.children,
        menuRef = _this$props2.menuRef,
        onExpand = _this$props2.onExpand,
        onCollapse = _this$props2.onCollapse,
        toggleMenu = _this$props2.toggleMenu,
        registerMenu = _this$props2.registerMenu,
        setTogglerCooldown = _this$props2.setTogglerCooldown,
        expandAnimationDuration = _this$props2.expandAnimationDuration,
        rest = _objectWithoutProperties(_this$props2, _excluded);
      var _this$state = this.state,
        shouldRender = _this$state.shouldRender,
        expanded = _this$state.expanded;
      if (!shouldRender) {
        return null;
      }

      // ARIA menu notes:
      // https://www.w3.org/TR/wai-aria-practices/examples/menu-button/menu-button-links.html

      // `tabIndex="-1"` is for calling `this.container.current.focus()`
      // when no `menuRef` is supplied.

      // `<OnFocusOutOrTapOutside/>` sets `onBlur` on the `<div/>`.
      return /*#__PURE__*/_react["default"].createElement(_OnFocusOutOrTapOutside["default"], {
        ref: this.onFocusOutRef,
        getContainerNode: this.getContainerNode,
        getTogglerNode: getTogglerNode,
        onFocusOut: this.onFocusOut,
        listenToTouches: false
      }, /*#__PURE__*/_react["default"].createElement("div", _extends({}, rest, {
        ref: this.container,
        "aria-hidden": !expanded,
        tabIndex: -1,
        onKeyDown: this.onKeyDown,
        className: (0, _classnames["default"])(className, /* Developers can define custom `:focus` style for the slideout menu. */
        /* (or better add `menuRef` property pointing to a component having `.focus()` method). */
        'rrui__outline', 'rrui__slideout-menu', {
          'rrui__slideout-menu--left': anchor === 'left',
          'rrui__slideout-menu--right': anchor === 'right',
          'rrui__slideout-menu--top': anchor === 'top',
          'rrui__slideout-menu--bottom': anchor === 'bottom',
          'rrui__slideout-menu--fullscreen': fullscreen,
          'rrui__slideout-menu--expanded': expanded
        })
      }), children));
    }
  }]);
  return SlideoutMenu;
}(PureComponent);
_defineProperty(SlideoutMenu, "propTypes", {
  anchor: _propTypes["default"].oneOf(['left', 'right', 'top', 'bottom']).isRequired,
  // isOpen : PropTypes.bool.isRequired,

  fullscreen: _propTypes["default"].bool.isRequired,
  // A result of `React.createRef()`.
  // Will be focused when the menu is opened.
  menuRef: _propTypes["default"].object,
  onCollapse: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  toggleMenu: _propTypes["default"].func.isRequired,
  registerMenu: _propTypes["default"].func.isRequired,
  setTogglerCooldown: _propTypes["default"].func.isRequired,
  getTogglerNode: _propTypes["default"].func.isRequired,
  // If `scrollIntoView` is `true` (which is the default)
  // then these two are gonna define the delay after which it scrolls into view.
  expandAnimationDuration: _propTypes["default"].number.isRequired,
  // CSS style object
  style: _propTypes["default"].object,
  // CSS class
  className: _propTypes["default"].string
});
_defineProperty(SlideoutMenu, "defaultProps", {
  // isOpen : false,
  anchor: 'left',
  fullscreen: false,
  expandAnimationDuration: 220
});
//# sourceMappingURL=SlideOutMenu.js.map