"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactCreateRef = _interopRequireDefault(require("react-create-ref"));
var _requestAnimationFrameTimeout = require("request-animation-frame-timeout");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } // For some weird reason, in Chrome, `setTimeout()` would lag up to a second (or more) behind.
// Turns out, Chrome developers have deprecated `setTimeout()` API entirely without asking anyone.
// Replacing `setTimeout()` with `requestAnimationFrame()` can work around that Chrome bug.
// https://github.com/bvaughn/react-virtualized/issues/722
// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = _react["default"].PureComponent || _react["default"].Component;

// Sits at the bottom of a page and displays notifications
var Snackbar = /*#__PURE__*/function (_PureComponent) {
  _inherits(Snackbar, _PureComponent);
  var _super = _createSuper(Snackbar);
  function Snackbar() {
    var _this;
    _classCallCheck(this, Snackbar);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {});
    _defineProperty(_assertThisInitialized(_this), "snackbar", (0, _reactCreateRef["default"])());
    _defineProperty(_assertThisInitialized(_this), "status", 'idle');
    _defineProperty(_assertThisInitialized(_this), "queue", []);
    // Displays the next notification in the queue
    _defineProperty(_assertThisInitialized(_this), "next", function () {
      // Get the next notification from the queue
      // (will be `undefined` if the queue is empty)
      var value = _this.queue.shift();

      // Reset the notification display
      _this.setState({
        value: value,
        queueSize: _this.queue.length,
        height: undefined,
        // wide: undefined,
        hiding: false
      });
      if (value) {
        _this.status = 'active';
        // `state.show` will be set to `true` later,
        // when the height of the element is measured
        // (which is after it renders)
      } else {
        // If the queue is empty, then just exit
        _this.status = 'idle';
      }
    });
    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      var hideAnimationDuration = _this.props.hideAnimationDuration;

      // Start the hiding animation for the notification
      _this.setState({
        show: false,
        hiding: true
      });

      // Display the next notification
      // after the currently being hidden one
      // finishes its hiding animation.
      _this.show_next_snack_timeout = (0, _requestAnimationFrameTimeout.setTimeout)(_this.next, hideAnimationDuration);
    });
    return _this;
  }
  _createClass(Snackbar, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _requestAnimationFrameTimeout.clearTimeout)(this.auto_hide_timer);
      (0, _requestAnimationFrameTimeout.clearTimeout)(this.show_next_snack_timeout);
      (0, _requestAnimationFrameTimeout.clearTimeout)(this.show_snack_timeout);
    }
  }, {
    key: "receiveNewValue",
    value: function receiveNewValue(prevProps) {
      var value = this.props.value;

      // If `value` has changed then push it to the queue.
      if (value && value !== prevProps.value) {
        // Add the notification to the queue
        this.push(value);
      }
    }

    // Adds a notification to the queue
  }, {
    key: "push",
    value: function push(newValue) {
      // Add the notification to the queue
      this.queue.push(newValue);
      this.setState({
        queueSize: this.queue.length
      });
      // If the notification queue was empty
      // then kick-start it.
      if (this.status === 'idle') {
        this.next();
      }
    }
  }, {
    key: "scheduleAutoHide",
    value: function scheduleAutoHide() {
      var _this$props = this.props,
        minTime = _this$props.minTime,
        lengthTimeFactor = _this$props.lengthTimeFactor;
      var value = this.state.value;
      if (value.duration === -1) {
        return;
      }
      // The total display duration (in milliseconds) of a snack
      // is `minTime + message.length * lengthTimeFactor`
      var length = typeof value.content === 'string' ? value.content.length : value.length || 0;
      var duration = value.duration || minTime + length * lengthTimeFactor;
      // Hide the notification after it expires.
      if (window.rruiCollapseOnFocusOut !== false) {
        this.auto_hide_timer = (0, _requestAnimationFrameTimeout.setTimeout)(this.hide, duration);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;
      var _this$state = this.state,
        height = _this$state.height,
        value = _this$state.value;
      var show = this.state.show;

      // If `value` got updated then push it to the list of `queue`.
      this.receiveNewValue(prevProps);

      // The notification DOM element has just been rendered
      // which means its dimensions are set by now.
      // Calculate the notification container DOM element height
      // so that the slide-from-bottom animation knows
      // its target Y-position for the CSS `translate` transform.
      if (value) {
        if (height === undefined) {
          height = this.snackbar.current.offsetHeight;
          // const wide = this.snackbar.current.offsetWidth === document.documentElement.clientWidth
          var marginBottom = parseInt(getComputedStyle(this.snackbar.current).marginBottom);
          this.setState({
            height: height,
            // wide,
            marginBottom: marginBottom
          });
        } else if (prevState.height === undefined) {
          // An "anti-lag" timeout added in order to set `show: true`
          // after the web browser has re-rendered.
          // Otherwise it would jump to fully shown in Chrome when
          // there's a queue of snacks waiting to be shown
          var anti_lag_timeout = 100;
          // Handle the changed state (due to the `.setState()` call above).
          this.show_snack_timeout = (0, _requestAnimationFrameTimeout.setTimeout)(function () {
            // Sometimes (for example, when the browser tab was in background)
            // this timer hasn't fired until the timeout
            _this2.setState({
              show: true
            });
          }, anti_lag_timeout);
        } else if (!prevState.show && show) {
          this.scheduleAutoHide();
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        type = _this$props2.type,
        placement = _this$props2.placement;
      var _this$state2 = this.state,
        show = _this$state2.show,
        value = _this$state2.value,
        height = _this$state2.height,
        marginBottom = _this$state2.marginBottom,
        hiding = _this$state2.hiding,
        queueSize = _this$state2.queueSize;
      var style = {};
      if (show) {
        var transform = "translateY(0)";
        if (getAlignment(placement) === 'center') {
          transform = "translateX(-50%) ".concat(transform);
        }
        style.transform = transform;
      } else {
        // If no snack is being shown,
        // or if a snack is about to be shown,
        // then shift it under the screen's bottom border
        // to show the slide-from-bottom animation at the next step.
        if (height !== undefined) {
          var _transform = "translateY(".concat(height + marginBottom, "px)");
          if (getAlignment(placement) === 'center') {
            _transform = "translateX(-50%) ".concat(_transform);
          }
          style.transform = _transform;
        }
        if (!hiding) {
          style.transition = 'none';
        }
      }
      var showCloseButton = value && (value.close || typeof value.content === 'string' && value.duration === -1);
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.snackbar,
        style: style,
        className: (0, _classnames["default"])('rrui__snackbar', value && value.type && "rrui__snackbar--".concat(value.type), {
          'rrui__snackbar--top': getEdge(placement) === 'top',
          'rrui__snackbar--bottom': getEdge(placement) === 'bottom',
          'rrui__snackbar--left': getAlignment(placement) === 'start',
          'rrui__snackbar--right': getAlignment(placement) === 'end',
          'rrui__snackbar--center': getAlignment(placement) === 'center',
          'rrui__snackbar--hidden': !show
        })
      }, value && !value.component && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, typeof value.content === 'string' && /*#__PURE__*/_react["default"].createElement("p", {
        className: "rrui__snackbar__text"
      }, value.content), typeof value.content !== 'string' && value.content), value && value.component && /*#__PURE__*/_react["default"].createElement(value.component, _objectSpread(_objectSpread({}, value.props), {}, {
        hide: this.hide
      })), (value && value.action || showCloseButton) && /*#__PURE__*/_react["default"].createElement("div", {
        className: "rrui__snackbar__actions"
      }, value && value.action && /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        onClick: value.action.onClick,
        className: "rrui__snackbar__action rrui__button-reset"
      }, value.action.title), showCloseButton && /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        onClick: this.hide,
        className: "rrui__snackbar__close rrui__button-reset"
      }, /*#__PURE__*/_react["default"].createElement(Close, null))), queueSize > 0 && /*#__PURE__*/_react["default"].createElement("div", {
        className: "rrui__snackbar__count"
      }, queueSize + 1));
    }
  }]);
  return Snackbar;
}(PureComponent);
exports["default"] = Snackbar;
_defineProperty(Snackbar, "propTypes", {
  // Snackbar value (either a message, or an object)
  value: _propTypes["default"].shape({
    // Notification content.
    content: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
    // Instead of `content` property one may supply `component` property
    // which must be a React component which receives all "rest" `value` properties
    // and also `hide`property (a function that hides the notification).
    component: _propTypes["default"].func,
    // `props` are passed to `component`.
    props: _propTypes["default"].object,
    // If `content` is a `string` then its `length` is calculated automatically.
    // Otherwise one may pass `length` manually.
    // It's used for calculating notification `duration`.
    length: _propTypes["default"].number,
    // `type` is appended as a BEM modifier to `.rrui__snackbar` CSS class.
    // E.g. `.rrui__snackbar--error` for `{ type: "error" }`.
    type: _propTypes["default"].string,
    // How long does the notification stay.
    // Pass `-1` for it to stay until it's closed manually.
    duration: _propTypes["default"].number,
    // (optional)
    // Action button on the right side.
    action: _propTypes["default"].shape({
      onClick: _propTypes["default"].func.isRequired,
      title: _propTypes["default"].string.isRequired
    }),
    // (optional)
    // Set to `true` to show a close button.
    // Close button is automatically shown
    // when `content` is text and `duration` is `-1`.
    close: _propTypes["default"].bool
  }),
  // Snackbar placement.
  placement: _propTypes["default"].oneOf(['top', 'top-start', 'top-end', 'bottom', 'bottom-start', 'bottom-end']).isRequired,
  // // "Snack" showing CSS animation duration.
  // // Is 225 milliseconds by default.
  // showAnimationDuration : PropTypes.number.isRequired,

  // "Snack" hiding CSS animation duration.
  // Is 195 milliseconds by default.
  hideAnimationDuration: _propTypes["default"].number.isRequired,
  // The total display duration (in milliseconds) of a snack
  // is `minTime + message.length * lengthTimeFactor`
  minTime: _propTypes["default"].number.isRequired,
  lengthTimeFactor: _propTypes["default"].number.isRequired
});
_defineProperty(Snackbar, "defaultProps", {
  placement: 'bottom-start',
  // showAnimationDuration : 225,
  hideAnimationDuration: 195,
  minTime: 1200,
  lengthTimeFactor: 60
});
function Close() {
  return /*#__PURE__*/_react["default"].createElement("svg", {
    className: "rrui__snackbar__close-icon",
    viewBox: "0 0 100 100"
  }, /*#__PURE__*/_react["default"].createElement("line", {
    stroke: "currentColor",
    strokeWidth: "10",
    x1: "2",
    y1: "2",
    x2: "98",
    y2: "98"
  }), /*#__PURE__*/_react["default"].createElement("line", {
    stroke: "currentColor",
    strokeWidth: "10",
    x1: "2",
    y1: "98",
    x2: "98",
    y2: "2"
  }));
}

/**
 * @param  {string} placement
 * @return {string} One of: "top", "bottom".
 */
function getEdge(placement) {
  var dashIndex = placement.indexOf('-');
  if (dashIndex >= 0) {
    return placement.slice(0, dashIndex);
  }
  return placement;
}

/**
 * @param  {string} placement
 * @return {string} One of: "left", "right", "center".
 */
function getAlignment(placement) {
  var dashIndex = placement.indexOf('-');
  if (dashIndex >= 0) {
    return placement.slice(dashIndex + '-'.length);
  }
  return 'center';
}
//# sourceMappingURL=Snackbar.js.map