"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _dom = require("./utility/dom");
var _WithError = _interopRequireDefault(require("./WithError"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = _react["default"].PureComponent || _react["default"].Component;
var Switcher = /*#__PURE__*/function (_PureComponent) {
  _inherits(Switcher, _PureComponent);
  var _super = _createSuper(Switcher);
  function Switcher() {
    var _this;
    _classCallCheck(this, Switcher);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {});
    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      return _this.button_0.focus();
    });
    _defineProperty(_assertThisInitialized(_this), "storeContainerComponent", function (_) {
      return _this.container = _;
    });
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      var onKeyDown = _this.props.onKeyDown;
      if (onKeyDown) {
        onKeyDown(event);
      }
      if (event.defaultPrevented) {
        return;
      }
      if ((0, _dom.submitFormOnCtrlEnter)(event, _this.input)) {
        return;
      }
      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }
      var _this$props = _this.props,
        onChange = _this$props.onChange,
        options = _this$props.options;
      switch (event.keyCode) {
        // Focus the previous option (if present) on left arrow.
        case 37:
          event.preventDefault();
          var previous_option_index = _this.previous_focused_option_index();
          if (previous_option_index !== undefined) {
            // Focus the option <button/> so that
            // a subsequent "Spacebar" keyDown
            // doesn't select the previously selected
            // option (e.g. the first one)
            _this["button_".concat(previous_option_index)].focus();

            // // Change the `value`
            // return onChange(options[previous_option_index].value)
          }

          return;

        // Focus the next option (if present) on right arrow.
        case 39:
          event.preventDefault();
          var next_option_index = _this.next_focused_option_index();
          if (next_option_index !== undefined) {
            // Focus the option <button/> so that
            // a subsequent "Spacebar" keyDown
            // doesn't select the previously selected
            // option (e.g. the first one)
            _this["button_".concat(next_option_index)].focus();

            // // Change the `value`
            // return onChange(options[next_option_index].value)
          }

          return;
      }
    });
    return _this;
  }
  _createClass(Switcher, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        disabled = _this$props2.disabled,
        options = _this$props2.options,
        showErrorMessage = _this$props2.showErrorMessage,
        error = _this$props2.error,
        ariaLabel = _this$props2.ariaLabel,
        style = _this$props2.style,
        className = _this$props2.className;
      return /*#__PURE__*/_react["default"].createElement(_WithError["default"], {
        error: showErrorMessage ? error : undefined,
        setRef: this.storeContainerComponent,
        onKeyDown: this.onKeyDown,
        style: style,
        className: (0, _classnames["default"])(className, 'rrui__switcher', {
          'rrui__switcher--disabled': disabled
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "rrui__input",
        role: "radiogroup",
        "aria-label": this.props['aria-label'] || ariaLabel,
        "aria-invalid": error ? true : undefined
      }, options.map(function (option, index) {
        return _this2.render_button(option, index);
      })));
    }
  }, {
    key: "render_button",
    value: function render_button(option, index) {
      var _this3 = this;
      var _this$props3 = this.props,
        options = _this$props3.options,
        value = _this$props3.value,
        disabled = _this$props3.disabled;
      var selected = value === option.value;
      var first = index === 0;
      var last = index === options.length - 1;
      return /*#__PURE__*/_react["default"].createElement("button", {
        key: option.value,
        ref: function ref(_ref) {
          return _this3["button_".concat(index)] = _ref;
        },
        type: "button",
        role: "radio",
        "aria-checked": selected,
        tabIndex: isAnythingSelected(value, options) ? selected ? 0 : -1 : first ? 0 : -1,
        disabled: disabled,
        onClick: this.chooser(option.value),
        className: (0, _classnames["default"])('rrui__button-reset', 'rrui__outline', 'rrui__switcher__option', {
          'rrui__switcher__option--selected': selected,
          // CSS selector performance optimization
          'rrui__switcher__option--disabled': disabled,
          // Ordering
          'rrui__switcher__option--first': first,
          'rrui__switcher__option--last': last,
          'rrui__switcher__option--middle': !first && !last
        })
      }, option.label);
    }

    // render_static()
    // {
    // 	const { options } = this.props
    // 	return options.map((option, index) => this.render_static_option(option, index))
    // }

    // render_static_option(option, index)
    // {
    // 	const { options, name, value } = this.props
    //
    // 	const first = index === 0
    // 	const last  = index === options.length - 1
    //
    // 	return (
    // 		<span
    // 			key={ option.value }
    // 			className={ classNames('rrui__button-reset', 'rrui__outline', 'rrui__switcher__option',
    // 			{
    // 				'rrui__switcher__option--first'  : first,
    // 				'rrui__switcher__option--last'   : last,
    // 				'rrui__switcher__option--middle' : !first && !last
    // 			}) }>
    // 			<input
    // 				type="radio"
    // 				name={ name }
    // 				checked={ value === option.value }/>
    // 			{ option.label }
    // 		</span>
    // 	)
    // }
  }, {
    key: "chooser",
    value: function chooser(value) {
      var _this4 = this;
      return function (event) {
        var _this4$props = _this4.props,
          disabled = _this4$props.disabled,
          onChange = _this4$props.onChange;
        if (disabled) {
          return;
        }

        // Call `onChange` only if `value` did actually change
        if (value !== _this4.props.value) {
          onChange(value);
        }
      };
    }
  }, {
    key: "getFocusedOptionIndex",
    value: function getFocusedOptionIndex() {
      var _this$props4 = this.props,
        options = _this$props4.options,
        value = _this$props4.value;
      var i = 0;
      while (i < options.length) {
        if (document.activeElement === this["button_".concat(i)]) {
          return i;
        }
        i++;
      }
    }

    // Get the previous focused option index (relative to the currently selected option).
  }, {
    key: "previous_focused_option_index",
    value: function previous_focused_option_index() {
      var i = this.getFocusedOptionIndex();
      return i === 0 ? i : i - 1;
    }

    // Get the next focused option index (relative to the currently selected option).
  }, {
    key: "next_focused_option_index",
    value: function next_focused_option_index() {
      var options = this.props.options;
      var i = this.getFocusedOptionIndex();
      return i === options.length - 1 ? i : i + 1;
    }
  }]);
  return Switcher;
}(PureComponent);
exports["default"] = Switcher;
_defineProperty(Switcher, "propTypes", {
  // A list of selectable options
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    // Option value
    value: _propTypes["default"].string.isRequired,
    // Option label
    label: _propTypes["default"].string.isRequired
  })).isRequired,
  // HTML form input `name` attribute
  name: _propTypes["default"].string,
  // If `true` then will be disabled
  disabled: _propTypes["default"].bool,
  // Indicates that the input is invalid.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  showErrorMessage: _propTypes["default"].bool,
  // The selected option value
  value: _propTypes["default"].any,
  // Is called when an option is selected
  onChange: _propTypes["default"].func.isRequired,
  // `aria-label` attribute.
  // Deprecated, use `aria-label` instead.
  ariaLabel: _propTypes["default"].string,
  // CSS class
  className: _propTypes["default"].string,
  // CSS style object
  style: _propTypes["default"].object
});
_defineProperty(Switcher, "defaultProps", {
  // Show `error` (if passed).
  showErrorMessage: true
});
function isAnythingSelected(value, options) {
  for (var _iterator = _createForOfIteratorHelperLoose(options), _step; !(_step = _iterator()).done;) {
    var option = _step.value;
    if (option.value === value) {
      return true;
    }
  }
  return false;
}
//# sourceMappingURL=Switcher.js.map