"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TextInputComponent = _interopRequireDefault(require("./TextInputComponent"));
var _WithError = _interopRequireDefault(require("./WithError"));
var _reduxForm = require("./utility/redux-form");
var _excluded = ["value", "onFocus", "onBlur", "showErrorMessage", "error", "style", "className", "password", "email"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function TextInput(_ref, ref) {
  var value = _ref.value,
    onFocus = _ref.onFocus,
    onBlur = _ref.onBlur,
    showErrorMessage = _ref.showErrorMessage,
    error = _ref.error,
    style = _ref.style,
    className = _ref.className,
    password = _ref.password,
    email = _ref.email,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useState = (0, _react.useState)(),
    _useState2 = _slicedToArray(_useState, 2),
    isFocused = _useState2[0],
    setFocused = _useState2[1];
  var _onFocus = (0, _react.useCallback)(function (event) {
    if (onFocus) {
      onFocus(event);
    }
    setFocused(true);
  }, [onFocus, setFocused]);
  var _onBlur = (0, _react.useCallback)(function (event) {
    if (onBlur) {
      (0, _reduxForm.onBlurForReduxForm)(onBlur, event, value);
    }
    setFocused(false);
  }, [onBlur, setFocused, value]);

  // Deprecated.
  // Use `type="password"` instead.
  if (password) {
    rest.type = 'password';
  }

  // Deprecated.
  // Use `type="email"` instead.
  if (email) {
    rest.type = 'email';
  }
  return /*#__PURE__*/_react["default"].createElement(_WithError["default"], {
    error: showErrorMessage ? error : undefined,
    style: style,
    className: (0, _classnames["default"])(className, 'rrui__text-input', {
      'rrui__text-input--focus': isFocused
    })
  }, /*#__PURE__*/_react["default"].createElement(_TextInputComponent["default"], _extends({}, rest, {
    ref: ref,
    value: value,
    error: error,
    onFocus: _onFocus,
    onBlur: _onBlur
  })));
}
TextInput = /*#__PURE__*/_react["default"].forwardRef(TextInput);
TextInput.propTypes = {
  // Text field label
  label: _propTypes["default"].string,
  // HTML form input `name` attribute
  name: _propTypes["default"].string,
  // Text field value
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  // Is called when the `value` is edited
  onChange: _propTypes["default"].func.isRequired,
  // A custom input component.
  inputComponent: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string]),
  // Indicates that the input is invalid.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  // If this flag is `true` then the `error` is shown (if passed).
  // If this flag is `false` then the `error` is not shown (even if passed).
  showErrorMessage: _propTypes["default"].bool,
  // Set to `true` to mark the field as required
  required: _propTypes["default"].bool,
  // `<input/>` placeholder
  placeholder: _propTypes["default"].string,
  // `<textarea/>` instead of an `<input type="text"/>`
  multiline: _propTypes["default"].bool,
  // Autoresize state saving/restoring for a `multiline` text input:
  initialHeight: _propTypes["default"].number,
  onHeightChange: _propTypes["default"].func,
  // Deprecated.
  // Use `type="email"` instead.
  // Sets HTML input `type` attribute to `email`
  email: _propTypes["default"].bool,
  // Deprecated.
  // Use `type="password"` instead.
  // Sets HTML input `type` attribute to `password`
  password: _propTypes["default"].bool,
  // Autofocuses the input field.
  // Deprecated. Use `autoFocus` instead.
  focus: _propTypes["default"].bool,
  // HTML `tabindex` attribute
  tabIndex: _propTypes["default"].number,
  // `<textarea/>` `rows` attribute (row count, i.e. height)
  rows: _propTypes["default"].number,
  // `<textarea/>` `cols` attribute (column count, i.e. width)
  cols: _propTypes["default"].number,
  // Is called when the input is focused
  onFocus: _propTypes["default"].func,
  // `onKeyDown` event handler
  onKeyDown: _propTypes["default"].func,
  // Is called when the input is blurred
  onBlur: _propTypes["default"].func,
  // Is called when the input is clicked
  onClick: _propTypes["default"].func,
  // CSS style object
  style: _propTypes["default"].object,
  // CSS name
  className: _propTypes["default"].string,
  // CSS style object for `<input/>`
  inputStyle: _propTypes["default"].object
};
TextInput.defaultProps = {
  // Show `error` (if passed).
  showErrorMessage: true
};
var _default = TextInput;
exports["default"] = _default;
//# sourceMappingURL=TextInput.js.map