"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TextInputInput = _interopRequireDefault(require("./TextInputInput"));
var _TextInputLabel = _interopRequireDefault(require("./TextInputLabel"));
var _excluded = ["icon", "className", "children"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// `<input/>` and its `<label/>`.
function TextInputComponent(_ref, ref) {
  var Icon = _ref.icon,
    className = _ref.className,
    children = _ref.children,
    rest = _objectWithoutProperties(_ref, _excluded);
  var id = rest.id,
    value = rest.value,
    required = rest.required,
    floatingLabel = rest.floatingLabel,
    label = rest.label,
    placeholder = rest.placeholder,
    multiline = rest.multiline,
    error = rest.error,
    containerRef = rest.containerRef;
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: containerRef,
    className: (0, _classnames["default"])('rrui__input', {
      'rrui__input--multiline': multiline
    })
  }, Icon && /*#__PURE__*/_react["default"].createElement(Icon, {
    className: "rrui__input-field__icon"
  }), /*#__PURE__*/_react["default"].createElement(_TextInputInput["default"], _extends({}, rest, {
    ref: ref,
    className: (0, _classnames["default"])(className, {
      'rrui__input-field--with-icon': Icon
    })
  })), label && /*#__PURE__*/_react["default"].createElement(_TextInputLabel["default"], {
    "aria-hidden": true,
    inputId: id,
    value: value,
    required: required,
    invalid: error,
    floats: floatingLabel && !placeholder
  }, label), children);
}
TextInputComponent = /*#__PURE__*/_react["default"].forwardRef(TextInputComponent);
TextInputComponent.propTypes = {
  // Set to `true` to mark the field as required.
  required: _propTypes["default"].bool.isRequired,
  // Indicates that the input is invalid.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool]),
  // Labels float by default.
  floatingLabel: _propTypes["default"].bool.isRequired,
  // `<input/>` icon.
  icon: _propTypes["default"].func
};
TextInputComponent.defaultProps = {
  // Set to `true` to mark the field as required.
  required: false,
  // Labels float by default.
  floatingLabel: true
};
var _default = TextInputComponent;
exports["default"] = _default;
//# sourceMappingURL=TextInputComponent.js.map