"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _throttle = _interopRequireDefault(require("lodash/throttle"));
var _reactCreateRef = _interopRequireDefault(require("react-create-ref"));
var _grid = require("./utility/grid");
var _dom = require("./utility/dom");
var _excluded = ["value", "multiline", "inputComponent", "focus", "onChange", "onKeyDown", "disabled", "readOnly", "label", "placeholder", "type", "autoresize", "error", "initialHeight", "onHeightChange", "inputStyle", "className", "containerRef", "floatingLabel", "required", "children"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function TextInput(_ref, ref) {
  var value = _ref.value,
    multiline = _ref.multiline,
    inputComponent = _ref.inputComponent,
    focus = _ref.focus,
    onChange = _ref.onChange,
    onKeyDown = _ref.onKeyDown,
    disabled = _ref.disabled,
    readOnly = _ref.readOnly,
    label = _ref.label,
    placeholder = _ref.placeholder,
    type = _ref.type,
    autoresize = _ref.autoresize,
    error = _ref.error,
    initialHeight = _ref.initialHeight,
    onHeightChange = _ref.onHeightChange,
    originalInputStyle = _ref.inputStyle,
    className = _ref.className,
    containerRef = _ref.containerRef,
    floatingLabel = _ref.floatingLabel,
    required = _ref.required,
    children = _ref.children,
    rest = _objectWithoutProperties(_ref, _excluded);
  var input = (0, _react.useRef)();
  var hiddenTextArea = (0, _react.useRef)();
  // hiddenTextAreaSingleLine = createRef()

  var autoResize = (0, _react.useMemo)(function () {
    if (multiline && autoresize) {
      return new Autoresize(function () {
        return input.current;
      }, function () {
        return hiddenTextArea.current;
      }, {
        initialHeight: initialHeight,
        onHeightChange: onHeightChange
      });
    }
  }, []);

  // On component update.
  (0, _react.useEffect)(function () {
    if (multiline && autoresize) {
      if (autoResize.initialized) {
        autoResize.resize();
      }
    }
  });

  // Client side rendering, javascript is enabled
  (0, _react.useEffect)(function () {
    if (multiline && autoresize) {
      // Doing `this.init()` here
      // because `<textarea/>` should autoresize
      // in case its `value` is set up front.
      autoResize.init();
      var onWindowResize = (0, _throttle["default"])(function (event) {
        return autoResize.resize();
      }, 100);
      window.addEventListener('resize', onWindowResize);
      return function () {
        window.removeEventListener('resize', onWindowResize);
      };
    }
  }, []);

  // The underlying `input` component
  // can pass both `event`s and `value`s
  // to this parent `onChange` listener.
  var _onChange = (0, _react.useCallback)(function (event) {
    // Extract `value` from the argument
    // of this `onChange` listener
    // (for convenience)
    var newValue = event;
    if (event && event.target) {
      newValue = event.target.value;
    }
    // Call the parent `onChange` handler
    // with the `value` as an argument (for convenience).
    // Call `onChange` only if `value` did actually change
    if (newValue !== value) {
      onChange(newValue);
    }
  }, [value, onChange]);
  var _onKeyDown = (0, _react.useCallback)(function (event) {
    if (onKeyDown) {
      onKeyDown(event);
    }
    if (event.defaultPrevented) {
      return;
    }
    if ((0, _dom.submitFormOnCtrlEnter)(event, input.current)) {
      return;
    }
  }, [onKeyDown, input]);
  var storeInputNode = (0, _react.useCallback)(function (node) {
    if (ref) {
      if (typeof ref === 'function') {
        ref(node);
      } else {
        ref.current = node;
      }
    }
    input.current = node;
  }, [input, ref]);
  var inputStyle = (0, _react.useMemo)(function () {
    if (multiline && autoresize) {
      return _objectSpread({
        resize: 'none'
      }, originalInputStyle);
    }
    return originalInputStyle;
  }, [multiline, autoresize, originalInputStyle]);
  var inputStyleAutoHeight = (0, _react.useMemo)(function () {
    if (multiline && autoresize) {
      return _objectSpread({
        height: autoResize.getHeight()
      }, inputStyle);
    }
    return inputStyle;
  }, [multiline, autoresize, inputStyle, autoResize]);
  var properties = _objectSpread(_objectSpread({
    // Placed `autoFocus` before `...rest` so that
    // it doesn't override an already passed `autoFocus`.
    // `focus` property is deprecated. Use `autoFocus` instead.
    autoFocus: focus,
    placeholder: placeholder,
    disabled: disabled,
    readOnly: readOnly
  }, rest), {}, {
    // Set `aria-label`, if none passed.
    'aria-label': rest['aria-label'] === undefined ? rest['aria-labelledby'] || rest['aria-describedby'] ? undefined : label : rest['aria-label'],
    // Set `aria-required`, if none passed.
    'aria-required': rest['aria-required'] === undefined ? required ? true : undefined : rest['aria-required'],
    // Set `aria-invalid`, if none passed.
    'aria-invalid': rest['aria-invalid'] === undefined ? error ? true : undefined : rest['aria-invalid'],
    ref: storeInputNode,
    value: isEmptyValue(value) ? '' : value,
    onChange: _onChange,
    onKeyDown: _onKeyDown,
    style: inputStyleAutoHeight,
    className: (0, _classnames["default"])(className,
    // `<TextInput/>` has `border-color` to indicate its `:focus` state.
    // Therefore the `outline` can be safely removed.
    'rrui__outline', 'rrui__input-element', 'rrui__input-field', {
      'rrui__input-field--empty': isEmptyValue(value),
      // CSS selector performance optimization
      'rrui__input-field--invalid': error,
      'rrui__input-field--disabled': disabled || readOnly,
      'rrui__input-field--multiline': multiline
    })
  });

  // In case of `multiline` set to `true`
  // this is gonna be a `<textarea/>`
  if (multiline) {
    if (autoresize) {
      return [
      /*#__PURE__*/
      // <textarea
      // 	key="textarea-measurement-single-line"
      // 	ref={this.hiddenTextAreaSingleLine}
      // 	rows="1"
      // 	readOnly
      // 	aria-hidden="true"
      // 	value=""
      // 	tabIndex={-1}
      // 	className={properties.className}
      // 	style={inputStyle ? { ...inputStyle, ...HIDDEN_TEXTAREA_STYLE } : HIDDEN_TEXTAREA_STYLE}/>,
      _react["default"].createElement("textarea", {
        key: "textarea-measurement",
        ref: hiddenTextArea,
        readOnly: true,
        "aria-hidden": true,
        value: properties.value,
        rows: properties.rows,
        tabIndex: -1,
        className: properties.className,
        style: inputStyle ? _objectSpread(_objectSpread({}, inputStyle), HIDDEN_TEXTAREA_STYLE) : HIDDEN_TEXTAREA_STYLE
      }), /*#__PURE__*/_react["default"].createElement("textarea", _extends({
        key: "textarea"
      }, properties))];
    }
    return /*#__PURE__*/_react["default"].createElement("textarea", _extends({
      key: "textarea"
    }, properties));
  }

  // Add `<input/>` `type` property.
  if (inputComponent === 'input') {
    properties.type = type || 'text';
  }
  return /*#__PURE__*/_react["default"].createElement(inputComponent, properties);
}
TextInput = /*#__PURE__*/_react["default"].forwardRef(TextInput);
TextInput.propTypes = {
  // `<input type/>` attribute.
  type: _propTypes["default"].string,
  // Whether `<textarea/>` should autoresize itself
  // (is `true` by default)
  autoresize: _propTypes["default"].bool.isRequired,
  initialHeight: _propTypes["default"].number,
  onHeightChange: _propTypes["default"].func,
  // In order for this to work properly
  // `<textarea/>` vertical padding should be `0`
  // and instead the padding should be defined on `<textarea/>` parent `<div/>`
  // like it's done in Material UI.
  // Otherwise it won't look pretty and the line of text near the top border
  // will be partially visible resulting in weird UX.
  // If `<textarea/>` vertical padding was `0`
  // the line of text near the top border wouldn't be visible.
  // // The maximum number of rows <textarea/> grows up to.
  // rowsMax          : PropTypes.number.isRequired,

  // Set to `false` to prevent the `<label/>` from floating
  floatingLabel: _propTypes["default"].bool.isRequired,
  // A custom input component.
  // (is `<input/>` by default)
  inputComponent: _propTypes["default"].elementType.isRequired,
  // Indicates that the input is invalid.
  error: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].bool])
};
TextInput.defaultProps = {
  // `<textarea/>` should autoresize itself
  autoresize: true,
  // Set to `false` to prevent the `<label/>` from floating
  floatingLabel: true,
  // A custom input component.
  // (is `<input/>` by default)
  inputComponent: 'input'

  // // The maximum number of rows <textarea/> grows up to.
  // rowsMax : 12
};
var _default = TextInput; // https://github.com/mui-org/material-ui/blob/master/packages/material-ui/src/InputBase/Textarea.js
exports["default"] = _default;
var HIDDEN_TEXTAREA_STYLE = {
  // Overflow also needed to here to remove the extra row
  // added to `<textarea/>`s in Firefox.
  overflow: 'hidden',
  // Visibility needed to hide the extra `<textarea/>` on iPads.
  visibility: 'hidden',
  position: 'absolute',
  // Don't know why is it here.
  whiteSpace: 'pre-wrap'
};
function isEmptyValue(value) {
  return value === '' || value === undefined || value === null;
}
var Autoresize = /*#__PURE__*/function () {
  function Autoresize(getInput, getHiddenTextArea, _ref2) {
    var _this = this;
    var initialHeight = _ref2.initialHeight,
      onHeightChange = _ref2.onHeightChange;
    _classCallCheck(this, Autoresize);
    // `height` works incorrectly in some weird cases.
    // For example, when `<textarea/>` is hidden when mounted
    // or when there's no stylesheet loaded yet.
    // For example, when stylesheets are included "dynamically"
    // like Webpack's `style-loader` does (is used in development mode,
    // or when using "code splitting" when "chunks" are `import()`ed dynamically).
    //
    // https://stackoverflow.com/questions/39400038/how-to-ensure-that-hot-css-loads-before-js-in-webpack-dev-server
    // https://github.com/webpack-contrib/style-loader/issues/269
    //
    // An alternative solution would be:
    //
    // input.current.minHeight = 0
    // input.current.minHeight = input.current.scrollHeight + bordersHeight.current
    //
    // or:
    //
    // input.current.minHeight = hiddenTextArea.current.scrollHeight + bordersHeight.current
    //
    // which wouldn't ever undersize the <textarea/>
    // but it would oversize it due to the incorrect
    // <textarea/> width before styles are loaded.
    //
    _defineProperty(this, "init", function () {
      // Exit if the component is no longer mounted.
      if (!_this.getInput()) {
        return;
      }
      _this.initAttempts++;
      _this.getMeasurements();
      if (_this.haveStylesLoaded()) {
        _this.resize();
      }
      _this.initialized = true;
      // Even if padding on <textarea/> has been set
      // it's still possible that `font-size` hasn't been set yet.
      // Or it could be another padding in a subsequent stylesheet.
      // So keep re-initializing <textarea/>, say, for a second.
      if (_this.initAttempts <= 5) {
        setTimeout(_this.init, 200);
      }
    });
    this.getInput = getInput;
    this.getHiddenTextArea = getHiddenTextArea;
    this.onHeightChange = onHeightChange;
    this.currentHeight = initialHeight;
    this.verticalPadding = 0;
    this.bordersHeight = 0;
    this.initAttempts = 0;
  }
  _createClass(Autoresize, [{
    key: "getHeight",
    value: function getHeight() {
      return this.currentHeight;
    }

    // Copy-pasted from Material UI on Oct 24th, 2018.
    // https://github.com/mui-org/material-ui/blob/master/packages/material-ui/src/InputBase/Textarea.js
    // There's a newer version of it (didn't copy-paste):
    // https://github.com/mui/material-ui/blob/master/packages/mui-base/src/TextareaAutosize/TextareaAutosize.js
  }, {
    key: "resize",
    value: function resize() {
      var hiddenTextArea = this.getHiddenTextArea();

      // "Guarding for **broken** shallow rendering method that call componentDidMount
      //  but doesn't handle refs correctly.
      //  To remove once the shallow rendering has been fixed."
      if (!hiddenTextArea) {
        return;
      }

      // const lineHeight = this.hiddenTextAreaSingleLine.current.scrollHeight - verticalPadding.current
      var height = hiddenTextArea.scrollHeight;

      // "Guarding for jsdom, where scrollHeight isn't present.
      //  See https://github.com/tmpvar/jsdom/issues/1013"
      if (height === undefined) {
        return;
      }

      // `.scrollHeight` doesn't include borders.
      // `.style.height` does include borders.
      height += this.bordersHeight;

      // `.scrollHeight` doesn't support fractional pixels precision ("retina" screens):
      // https://stackoverflow.com/questions/21666892/fractional-scrollheight
      // That would sometimes result in weird sub-pixel changes of height where they aren't required.
      // For example, when initially rendering a "stub" single-row `<textarea/>`
      // and then, after measuring it, rendering the "real" one that is `0.5px` higher.
      // Libraries like `virtual-scroller` wouldn't like such "unmotivated" changes in the height.
      var nonScrollHeight = hiddenTextArea.getBoundingClientRect().height;
      if (Math.abs(height - nonScrollHeight) < 1) {
        // `nonScrollHeight` has fractional pixel precision.
        height = nonScrollHeight;
      }

      // if (height <= this.minHeight) {
      // 	height = this.minHeight
      // }

      // This seems no longer relevant:
      //
      // // For some weird reason Chrome on Windows 10
      // // requires an extra pixel been added
      // // to avoid showing vertical scrollbar.
      // // (Oct 24th, 2018)
      // // else {
      // 	height += 1
      // // }

      // "Need a large enough different to update the height.
      //  This prevents infinite rendering loop."
      // By that, they were referring to the `> 1` condition below.
      // It's unclear what exact cause of the issue they were talking about.
      if (this.currentHeight === undefined || Math.abs(this.currentHeight - height) > 1) {
        this.currentHeight = height;
        // `.style.height` includes borders.
        this.getInput().style.height = height + 'px';
        if (this.onHeightChange) {
          this.onHeightChange(height);
        }
      }
    }
  }, {
    key: "getMeasurements",
    value: function getMeasurements() {
      var style = getComputedStyle(this.getInput());

      // // Measurements can be in `em`s/`rem`s/`pt`s which can give fractional pixel sizes.
      // // `style.height` includes borders.
      // currentHeight.current = parseFloat(style.height)
      // this.minHeight = currentHeight.current

      // Get vertical padding.
      // Measurements can be in `em`s/`rem`s/`pt`s which can give fractional pixel sizes.
      this.verticalPadding = parseFloat(style.paddingTop) + parseFloat(style.paddingBottom);

      // Top and bottom borders are extra height,
      // because `.scrollHeight` doesn't include borders.
      // Measurements can be in `em`s/`rem`s/`pt`s which can give fractional pixel sizes.
      this.bordersHeight = parseFloat(style.borderTopWidth) + parseFloat(style.borderBottomWidth);
    }

    // Even if padding on <textarea/> has been set
    // it's still possible that `font-size` hasn't been set yet.
    // (it happened in a project)
    // So this function doesn't guarantee anything.
  }, {
    key: "haveStylesLoaded",
    value: function haveStylesLoaded() {
      // The default <textarea/> top/bottom padding in Chrome on Windows is 2px.
      // `react-responsive-ui` multiline text inputs are supposed to have larger padding.
      return this.verticalPadding > 2 * 2;
    }
  }]);
  return Autoresize;
}();
//# sourceMappingURL=TextInputInput.js.map