"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getLanguageFromLocale;
// Returns a language from a BCP 47 "language tag".
// Example: `"ru-RU"` -> `"ru"`.
// https://en.wikipedia.org/wiki/IETF_language_tag
function getLanguageFromLocale(locale) {
  var dashIndex = locale.indexOf('-');
  if (dashIndex >= 0) {
    return locale.slice(0, dashIndex);
  }
  return locale;
}
//# sourceMappingURL=getLanguageFromLocale.js.map