"use strict";

var _getTerritoryFromLocale = _interopRequireDefault(require("./getTerritoryFromLocale"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('getTerritoryFromLocale', function () {
  it('should get territory from locale', function () {
    // Doesn't have territory.
    expect((0, _getTerritoryFromLocale["default"])('ru')).to.be.undefined;
    expect((0, _getTerritoryFromLocale["default"])('en-001')).to.be.undefined;
    expect((0, _getTerritoryFromLocale["default"])('en-Latn')).to.be.undefined;

    // Has territory.
    expect((0, _getTerritoryFromLocale["default"])('en-US')).to.equal('US');
    expect((0, _getTerritoryFromLocale["default"])('en-Latn-US')).to.equal('US');
    expect((0, _getTerritoryFromLocale["default"])('he-IL-u-ca-hebrew-tz-jeruslm')).to.equal('IL');
  });
});
//# sourceMappingURL=getTerritoryFromLocale.test.js.map