"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ignoreInvalidDateObjects;
// Converts `null` to `undefined`.
// Converts "Invalid Date" to `undefined`.
// (specially for `sequelize`)
function ignoreInvalidDateObjects(value) {
  if (value === null) {
    return;
  }

  // Check if `value` is "Invalid Date".
  if (value instanceof Date && isNaN(value.getTime())) {
    return;
  }
  return value;
}
//# sourceMappingURL=ignoreInvalidDateObjects.js.map