"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _parseDate = _interopRequireWildcard(require("./parseDate"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
describe('parseDate', function () {
  it('should parse dates', function () {
    expect((0, _parseDate["default"])('fadsfasd', 'dd.mm.yyyy', true)).to.be.undefined;
    expect((0, _parseDate["default"])('28.02.2017', 'dd.mm.yyyy', true).toISOString()).to.equal('2017-02-28T00:00:00.000Z');
    expect((0, _parseDate["default"])('12/02/2017', 'mm/dd/yyyy', true).toISOString()).to.equal('2017-12-02T00:00:00.000Z');
    expect((0, _parseDate["default"])('99/99/2017', 'mm/dd/yyyy', true).toISOString()).to.equal('2025-06-07T00:00:00.000Z');
    expect((0, _parseDate["default"])('02/03/17', 'mm/dd/yy', true).toISOString()).to.equal('2017-02-03T00:00:00.000Z');
  });
  it('should detect if a string corresponds to template', function () {
    expect((0, _parseDate.correspondsToTemplate)('1231231234', 'dd.mm.yyyy')).to.equal(false);
    expect((0, _parseDate.correspondsToTemplate)('12.12.1234', 'dd.mm.yyyy')).to.equal(true);
  });
});
//# sourceMappingURL=parseDate.test.js.map