"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = transformDateInputAccordingToTemplate;
var _isDigit = _interopRequireDefault(require("./isDigit"));
var _parseDate = require("./parseDate");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function transformDateInputAccordingToTemplate(value, format) {
  var i = 0;
  while (i < value.length && i < format.length) {
    if ((0, _parseDate.isDateFormatUnitCharacter)(format[i])) {
      if (!(0, _isDigit["default"])(value[i])) {
        break;
      }
    } else if (format[i] !== value[i]) {
      if ((0, _isDigit["default"])(value[i])) {
        break;
      }
      // Fix the punctuation character.
      value = value.slice(0, i) + format[i] + value.slice(i + 1);
    }
    i++;
  }
  return value.slice(0, i);
}
//# sourceMappingURL=transformDateInputAccordingToTemplate.js.map