function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import WithError from './WithError';
import { submitFormOnCtrlEnter } from './utility/dom';
import { onBlurForReduxForm } from './utility/redux-form';

// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = React.PureComponent || React.Component;

// http://tympanus.net/codrops/2013/10/15/animated-checkboxes-and-radio-buttons-with-svg/
var Checkbox = /*#__PURE__*/function (_PureComponent) {
  _inherits(Checkbox, _PureComponent);
  var _super = _createSuper(Checkbox);
  function Checkbox() {
    var _this;
    _classCallCheck(this, Checkbox);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {});
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      var onKeyDown = _this.props.onKeyDown;
      if (onKeyDown) {
        onKeyDown(event);
      }
      if (event.defaultPrevented) {
        return;
      }
      if (submitFormOnCtrlEnter(event, _this.checkbox)) {
        return;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onFocus", function (event) {
      var onFocus = _this.props.onFocus;
      if (onFocus) {
        onFocus(event);
      }
      _this.setState({
        isFocused: true
      });
    });
    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      var _this$props = _this.props,
        onBlur = _this$props.onBlur,
        value = _this$props.value;
      if (onBlur) {
        onBlurForReduxForm(onBlur, event, value);
      }
      _this.setState({
        isFocused: false
      });
    });
    _defineProperty(_assertThisInitialized(_this), "storeInstance", function (ref) {
      return _this.checkbox = ref;
    });
    // render_static()
    // {
    // 	const { name, value, focus, disabled, children } = this.props
    //
    // 	return (
    // 		<div className="rrui__rich__fallback">
    // 			{/* This checkbox will be sent as either "on" or `undefined` */}
    // 			<input
    // 				type="checkbox"
    // 				name={ name }
    // 				disabled={ disabled }
    // 				defaultChecked={ value }
    // 				autoFocus={ focus }/>
    //
    // 			<label className="rrui__checkbox__label rrui__checkbox__label--fallback">
    // 				{ children }
    // 			</label>
    // 		</div>
    // 	)
    // }
    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      return _this.checkbox.focus();
    });
    _defineProperty(_assertThisInitialized(_this), "toggle", function (event) {
      // If a link was clicked - don't treat it as a checkbox label click.
      // (is used for things like "✓ Read and accepted the <a>licence agreement</a>")
      if (event.target.tagName.toLowerCase() === 'a') {
        return;
      }
      _this.focus();
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        onChange = _this$props2.onChange,
        value = _this$props2.value;
      if (disabled) {
        return;
      }
      onChange(!value);
    });
    return _this;
  }
  _createClass(Checkbox, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        id = _this$props3.id,
        value = _this$props3.value,
        error = _this$props3.error,
        showErrorMessage = _this$props3.showErrorMessage,
        multiline = _this$props3.multiline,
        disabled = _this$props3.disabled,
        ariaLabel = _this$props3.ariaLabel,
        children = _this$props3.children,
        style = _this$props3.style,
        className = _this$props3.className,
        onClick = _this$props3.onClick;
      var isFocused = this.state.isFocused;
      return /*#__PURE__*/React.createElement(WithError, {
        error: showErrorMessage ? error : undefined,
        style: style,
        className: classNames(className, 'rrui__checkbox', {
          'rrui__checkbox--checked': value,
          'rrui__checkbox--invalid': error,
          'rrui__checkbox--disabled': disabled,
          'rrui__checkbox--multiline': multiline,
          'rrui__checkbox--focus': isFocused
        })
      }, /*#__PURE__*/React.createElement("label", {
        className: classNames('rrui__input', {
          'rrui__input--multiline': multiline
        })
      }, /*#__PURE__*/React.createElement("span", {
        className: "rrui__checkbox__checkbox"
      }, /*#__PURE__*/React.createElement("input", {
        id: id,
        ref: this.storeInstance,
        type: "checkbox",
        "aria-label": this.props['aria-label'] || ariaLabel,
        "aria-labelledby": this.props['aria-labelledby'],
        "aria-describedby": this.props['aria-describedby'],
        "aria-invalid": error ? true : undefined,
        checked: value,
        disabled: disabled,
        onClick: onClick,
        onChange: this.toggle,
        onKeyDown: this.onKeyDown,
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        className: "rrui__checkbox__input"
      }), /*#__PURE__*/React.createElement("svg", {
        className: classNames('rrui__checkbox__box', {
          'rrui__checkbox__box--checked': value
        }),
        focusable: "false",
        viewBox: "0 0 24 24",
        "aria-hidden": "true"
      }, /*#__PURE__*/React.createElement("path", {
        d: value ? CHECKBOX_CHECKED_PATH : CHECKBOX_UNCHECKED_PATH
      }), " }"), /*#__PURE__*/React.createElement("span", {
        className: "rrui__checkbox__box-background"
      }), /*#__PURE__*/React.createElement("span", {
        className: "rrui__checkbox__focus-ring"
      })), children && /*#__PURE__*/React.createElement("span", {
        className: classNames('rrui__checkbox__label', {
          'rrui__checkbox__label--multiline': multiline
        })
      }, children)));
    }
  }]);
  return Checkbox;
}(PureComponent);
_defineProperty(Checkbox, "propTypes", {
  // HTML `id` attribute.
  id: PropTypes.string,
  // HTML form field "name"
  name: PropTypes.string,
  // `true`/`false`
  value: PropTypes.bool.isRequired,
  // Set to `true` to enable multiline label
  multiline: PropTypes.bool.isRequired,
  // Disables the checkbox
  disabled: PropTypes.bool.isRequired,
  // Indicates that the input is invalid.
  error: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  showErrorMessage: PropTypes.bool,
  // `onClick` handler
  onClick: PropTypes.func,
  // `onChange` handler
  onChange: PropTypes.func,
  // When `true` autofocuses the checkbox
  focus: PropTypes.bool.isRequired,
  // `aria-label` attribute.
  // Deprecated, use `aria-label` instead.
  ariaLabel: PropTypes.string,
  // The label (text)
  children: PropTypes.node,
  // CSS class
  className: PropTypes.string,
  // CSS style object
  style: PropTypes.object
});
_defineProperty(Checkbox, "defaultProps", {
  disabled: false,
  value: false,
  multiline: false,
  focus: false,
  // Show `error` (if passed).
  showErrorMessage: true
});
export { Checkbox as default };
var CHECKBOX_CHECKED_PATH = "M21.3,0H2.7C1.2,0,0,1.2,0,2.7v18.7C0,22.8,1.2,24,2.7,24h18.7c1.5,0,2.7-1.2,2.7-2.7V2.7C24,1.2,22.8,0,21.3,0z M9.3,18.7 L2.7,12l1.9-1.9l4.8,4.8L19.5,4.8l1.9,1.9L9.3,18.7z";
var CHECKBOX_UNCHECKED_PATH = "M21.2,0H2.9C1.3,0,0,1.3,0,2.9v18.3C0,22.8,1.3,24,2.9,24h18.3c1.6,0,2.8-1.3,2.8-2.8V2.9C24,1.3,22.8,0,21.2,0z M22.3,20.7c0,0.9-0.8,1.7-1.7,1.7H3.4c-0.9,0-1.7-0.8-1.7-1.7V3.4c0-0.9,0.8-1.7,1.7-1.7h17.2c0.9,0,1.7,0.8,1.7,1.7V20.7z";

// Thin.
// const CHECKBOX_UNCHECKED_PATH = "M21.2,0H2.9C1.3,0,0,1.3,0,2.8v18.3C0,22.7,1.3,24,2.9,24h18.3c1.6,0,2.8-1.3,2.8-2.8V2.8C24,1.3,22.8,0,21.2,0z M23.2,20.3c0,1.6-1.3,2.8-2.8,2.8H3.7c-1.6,0-2.8-1.3-2.8-2.8V3.7c0-1.6,1.3-2.8,2.8-2.8h16.6c1.6,0,2.8,1.3,2.8,2.8V20.3z"
//# sourceMappingURL=Checkbox.js.map