import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
export default function Close(props) {
  var onClick = props.onClick,
    closeLabel = props.closeLabel,
    className = props.className,
    children = props.children;
  return /*#__PURE__*/React.createElement("button", {
    type: "button",
    onClick: onClick,
    "aria-label": props['aria-label'] || closeLabel,
    className: classNames('rrui__button-reset', 'rrui__outline', 'rrui__close', className)
  }, children);
}
export var CloseIcon = function CloseIcon() {
  return /*#__PURE__*/React.createElement("svg", {
    viewBox: "0 0 22 21",
    className: "rrui__close__icon"
  }, /*#__PURE__*/React.createElement("g", {
    stroke: "none",
    strokeWidth: "1",
    fill: "none",
    fillRule: "evenodd",
    strokeLinecap: "round"
  }, /*#__PURE__*/React.createElement("g", {
    className: "rrui__close__icon-path",
    transform: "translate(-1367.000000, -40.000000)",
    strokeWidth: "1"
  }, /*#__PURE__*/React.createElement("g", {
    transform: "translate(1368.000000, 41.000000)"
  }, /*#__PURE__*/React.createElement("path", {
    d: "M0.807611845,0.307611845 L19.1923882,18.6923882"
  }), /*#__PURE__*/React.createElement("path", {
    d: "M0.807611845,0.307611845 L19.1923882,18.6923882",
    transform: "translate(10.000000, 9.500000) scale(-1, 1) translate(-10.000000, -9.500000) "
  })))));
};
Close.propTypes = {
  onClick: PropTypes.func.isRequired,
  closeLabel: PropTypes.string.isRequired,
  className: PropTypes.string,
  children: PropTypes.node.isRequired
};
Close.defaultProps = {
  closeLabel: 'Close'
};
//# sourceMappingURL=Close.js.map