var _excluded = ["buttonTitle", "disabled", "style", "className", "button", "buttonComponent", "buttonProps", "buttonClassName", "toggleElement", "toggler", "togglerAriaLabel", "togglerAriaHasPopup", "togglerClassName", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useCallback, useRef } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import createRef from 'react-create-ref';
import ExpandableList from './ExpandableList';
import List from './List';
import Close, { CloseIcon } from './Close';
import { focus as focusElement } from './utility/focus';
export default function ExpandableMenu(props) {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isExpanded = _useState2[0],
    setExpanded = _useState2[1];

  // The DOM Element reference is only used to determine
  // whether the focus is "inside" the component or "outside" of it,
  // and also for focusing the `<button/>` when closing expandable menu.
  var buttonRef = useRef();
  var listRef = useRef();

  // (legacy) (deprecated)
  // Is used to focus legacy togglers.
  var togglerRef = useRef();
  var buttonRefExternal = props.buttonRef;
  var setToggleButtonRef = useCallback(function (instance) {
    buttonRef.current = instance;
    if (buttonRefExternal) {
      if (typeof buttonRefExternal === 'function') {
        buttonRefExternal(instance);
      } else {
        buttonRefExternal.current = instance;
      }
    }
  }, [buttonRefExternal]);
  var focus = useCallback(function () {
    // `togglerRef` is deprecated.
    focusElement(togglerRef.current || buttonRef.current);
  }, []);

  // Returns a `Promise`.
  var expand = useCallback(function () {
    return listRef.current.expand();
  }, [listRef]);

  // Returns a `Promise`.
  var collapse = useCallback(function () {
    return listRef.current.collapse();
  }, [listRef]);

  // Returns a `Promise`.
  var toggle = useCallback(function () {
    return listRef.current.toggle();
  }, [listRef]);
  var onExpand = useCallback(function () {
    setExpanded(true);
  }, []);
  var onCollapse = useCallback(function (_ref) {
    var focusOut = _ref.focusOut;
    if (!focusOut) {
      focus();
    }
    setExpanded(false);
    // // A workaround for Safari (both macOS and iOS) bug: `<button/>`s not getting focus.
    // // https://stackoverflow.com/questions/20359962/jquery-mobile-focusout-event-for-relatedtarget-returns-incorrect-result-in-safar
    // this.cooldown = true
    // this.cooldownTimer = setTimeout(() => this.cooldown = false, 30)
  }, [focus]);
  var onFocusOut = useCallback(function () {
    // `window.rruiCollapseOnFocusOut` can be used
    // for debugging expandable contents.
    if (window.rruiCollapseOnFocusOut !== false) {
      collapse();
    }
  }, [collapse]);
  var getButtonElement = useCallback(function () {
    return buttonRef.current;
  }, []);
  var onBlur = useCallback(function (event) {
    if (listRef.current) {
      listRef.current.onBlur(event);
    }
  }, []);
  var onClick = useCallback(function (event) {
    // // A workaround for Safari (both macOS and iOS) bug: `<button/>`s not getting focus.
    // // https://stackoverflow.com/questions/20359962/jquery-mobile-focusout-event-for-relatedtarget-returns-incorrect-result-in-safar
    // if (!this.cooldown) {
    toggle();
    // }
  }, [toggle]);
  var onKeyDown = useCallback(function (event) {
    if (event.defaultPrevented) {
      return;
    }
    if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
      return;
    }
    switch (event.keyCode) {
      // "Up" arrow.
      // Select the previous item (if present).
      case 38:
      // "Down" arrow.
      // Select the next item (if present).
      case 40:
        return listRef.current.onKeyDown(event);

      // "Enter".
      case 13:
        // Submit containing `<form/>`.
        // Expand otherwise.
        expand();
        return event.preventDefault();
    }
  }, [expand]);
  var buttonTitle = props.buttonTitle,
    disabled = props.disabled,
    style = props.style,
    className = props.className,
    button = props.button,
    buttonComponent = props.buttonComponent,
    buttonProps = props.buttonProps,
    buttonClassName = props.buttonClassName,
    toggleElement = props.toggleElement,
    toggler = props.toggler,
    togglerAriaLabel = props.togglerAriaLabel,
    togglerAriaHasPopup = props.togglerAriaHasPopup,
    togglerClassName = props.togglerClassName,
    children = props.children,
    rest = _objectWithoutProperties(props, _excluded);

  // `button` is a legacy property name.
  // `buttonComponent` is a new property name.
  var CustomButtonComponent = buttonComponent || button;
  var menuToggler;
  var menuItems;
  if (CustomButtonComponent || buttonProps || toggleElement || toggler) {
    menuItems = children;
    var DefaultButtonComponent = 'button';
    var defaultButtonComponentClassNames = 'rrui__button-reset' + ' ' + 'rrui__outline';
    var defaultButtonComponentProps = {
      type: 'button'
    };
    var isDefaultButtonComponent = !CustomButtonComponent;
    var ButtonComponent = isDefaultButtonComponent ? 'button' : CustomButtonComponent;
    var buttonComponentChildren = toggleElement || (buttonProps ? buttonProps.children : null) || (toggler ? /*#__PURE__*/React.createElement(toggler) : null);
    menuToggler = /*#__PURE__*/React.createElement(ButtonComponent, _extends({
      "aria-haspopup": togglerAriaHasPopup,
      "aria-label": togglerAriaLabel,
      title: buttonTitle,
      disabled: disabled,
      className: classNames(togglerClassName, buttonClassName, isDefaultButtonComponent ? defaultButtonComponentClassNames : undefined)
    }, isDefaultButtonComponent ? defaultButtonComponentProps : buttonProps, {
      ref: setToggleButtonRef,
      onClick: onClick,
      onKeyDown: onKeyDown,
      onBlur: onBlur,
      "aria-expanded": isExpanded
    }), buttonComponentChildren);
  } else {
    // Legacy way: the first child was the toggler.
    menuItems = React.Children.toArray(children);
    menuToggler = menuItems.shift();
    menuToggler = /*#__PURE__*/React.createElement("div", {
      ref: buttonRef,
      onClick: onClick,
      onKeyDown: onKeyDown,
      onBlur: onBlur
    }, /*#__PURE__*/React.cloneElement(menuToggler, {
      ref: togglerRef
    }));
  }
  return /*#__PURE__*/React.createElement("div", {
    style: style,
    className: classNames('rrui__menu', className)
  }, menuToggler, /*#__PURE__*/React.createElement(ExpandableList, _extends({}, rest, {
    animation: "fade-up",
    ref: listRef,
    "aria-label": props['aria-label'],
    tabbable: false,
    scrollMaxItems: 0,
    onCollapse: onCollapse,
    onExpand: onExpand,
    onFocusOut: onFocusOut,
    getTogglerNode: getButtonElement,
    focusSelectedItem: false,
    className: "rrui__shadow"
  }), menuItems));
}
ExpandableMenu.propTypes = {
  // Component CSS class
  className: PropTypes.string,
  // CSS style object
  style: PropTypes.object,
  // `aria-label` for the "Close" button
  // (which is an "x" visible in fullscreen mode).
  closeLabel: PropTypes.string,
  // The "x" button icon that closes the `<Select/>`
  // in fullscreen mode on mobile devices.
  closeButtonIcon: PropTypes.oneOfType([PropTypes.func, PropTypes.oneOf([false])]).isRequired,
  // Must accept a `ref`.
  // Receives properties: `onClick`, `onKeyDown`, `onBlur`, `aria-expanded`.
  buttonComponent: PropTypes.elementType,
  // `button` is a legacy property name.
  // `buttonComponent` is a new property name.
  button: PropTypes.elementType,
  buttonProps: PropTypes.object,
  buttonClassName: PropTypes.string,
  toggleElement: PropTypes.node,
  // (deprecated, use `button` component instead)
  toggler: PropTypes.func,
  // (deprecated, use `buttonProps` instead)
  togglerAriaLabel: PropTypes.string,
  // (deprecated, use `buttonProps` instead)
  togglerAriaHasPopup: PropTypes.string,
  // (deprecated, use `buttonProps` instead)
  togglerClassName: PropTypes.string,
  // A `ref` for the toggle button
  buttonRef: PropTypes.object,
  buttonTitle: PropTypes.string,
  alignment: PropTypes.oneOf(['left', 'right']),
  disabled: PropTypes.bool
};
ExpandableMenu.defaultProps = {
  // The "x" button icon that closes the `<Select/>`
  // in fullscreen mode on mobile devices.
  closeButtonIcon: CloseIcon
};
//# sourceMappingURL=ExpandableMenu.js.map