function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';

// The original idea is by `what-input` library.
// https://github.com/ten1seven/what-input
//
// Still, seems that "Screen Readers" emit all sorts of
// pointer events even when using only keyboard navigation.
// https://patrickhlauke.github.io/touch/tests/results/#desktop-assistive-technology-events
//
// So, listening to pointer events and deciding on the input method
// is not a 100%-formally-correct technique (though it does make perfect sense).
// So, for having one's ass covered it's not considered a reliable strategy.
//
// There's a script listening for `mousedown` events on each button/link/input
// which then removes the outline (and adds it when it detects a keyboard event).
// https://github.com/lindsayevans/outline.js
var KeyboardNavigationListener = /*#__PURE__*/function (_React$Component) {
  _inherits(KeyboardNavigationListener, _React$Component);
  var _super = _createSuper(KeyboardNavigationListener);
  function KeyboardNavigationListener() {
    var _this;
    _classCallCheck(this, KeyboardNavigationListener);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }
      switch (event.keyCode) {
        // "Tab".
        case 9:
          if (!_this.tabbing) {
            _this.tabbing = true;
            document.body.classList.add('rrui__tabbing');
          }
          return;
      }
    });
    _defineProperty(_assertThisInitialized(_this), "onPointerEvent", function (event) {
      if (_this.tabbing) {
        _this.tabbing = false;
        document.body.classList.remove('rrui__tabbing');
      }
    });
    return _this;
  }
  _createClass(KeyboardNavigationListener, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('keydown', this.onKeyDown);
      // "Pointer" events are mouse/stylus/pen/touch events.
      // https://developer.mozilla.org/en-US/docs/Web/API/Pointer_events
      if (window.PointerEvent) {
        window.addEventListener('pointermove', this.onPointerEvent);
        window.addEventListener('pointerdown', this.onPointerEvent);
      } else {
        // Mouse events.
        window.addEventListener('mousemove', this.onPointerEvent);
        window.addEventListener('mousedown', this.onPointerEvent);
        // Touch events.
        if ('ontouchstart' in window) {
          window.addEventListener('touchstart', this.onPointerEvent);
          window.addEventListener('touchend', this.onPointerEvent);
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('keydown', this.onKeyDown);
      // "Pointer" events are mouse/stylus/pen/touch events.
      // https://developer.mozilla.org/en-US/docs/Web/API/Pointer_events
      if (window.PointerEvent) {
        window.removeEventListener('pointermove', this.onPointerEvent);
        window.removeEventListener('pointerdown', this.onPointerEvent);
      } else {
        // Mouse events.
        window.removeEventListener('mousemove', this.onPointerEvent);
        window.removeEventListener('mousedown', this.onPointerEvent);
        // Touch events.
        if ('ontouchstart' in window) {
          window.removeEventListener('touchstart', this.onPointerEvent);
          window.removeEventListener('touchend', this.onPointerEvent);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);
  return KeyboardNavigationListener;
}(React.Component);
export { KeyboardNavigationListener as default };
//# sourceMappingURL=KeyboardNavigationListener.js.map