var _excluded = ["icon", "className", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Input from './TextInputInput';
import Label from './TextInputLabel';

// `<input/>` and its `<label/>`.
function TextInputComponent(_ref, ref) {
  var Icon = _ref.icon,
    className = _ref.className,
    children = _ref.children,
    rest = _objectWithoutProperties(_ref, _excluded);
  var id = rest.id,
    value = rest.value,
    required = rest.required,
    floatingLabel = rest.floatingLabel,
    label = rest.label,
    placeholder = rest.placeholder,
    multiline = rest.multiline,
    error = rest.error,
    containerRef = rest.containerRef;
  return /*#__PURE__*/React.createElement("div", {
    ref: containerRef,
    className: classNames('rrui__input', {
      'rrui__input--multiline': multiline
    })
  }, Icon && /*#__PURE__*/React.createElement(Icon, {
    className: "rrui__input-field__icon"
  }), /*#__PURE__*/React.createElement(Input, _extends({}, rest, {
    ref: ref,
    className: classNames(className, {
      'rrui__input-field--with-icon': Icon
    })
  })), label && /*#__PURE__*/React.createElement(Label, {
    "aria-hidden": true,
    inputId: id,
    value: value,
    required: required,
    invalid: error,
    floats: floatingLabel && !placeholder
  }, label), children);
}
TextInputComponent = /*#__PURE__*/React.forwardRef(TextInputComponent);
TextInputComponent.propTypes = {
  // Set to `true` to mark the field as required.
  required: PropTypes.bool.isRequired,
  // Indicates that the input is invalid.
  error: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  // Labels float by default.
  floatingLabel: PropTypes.bool.isRequired,
  // `<input/>` icon.
  icon: PropTypes.func
};
TextInputComponent.defaultProps = {
  // Set to `true` to mark the field as required.
  required: false,
  // Labels float by default.
  floatingLabel: true
};
export default TextInputComponent;
//# sourceMappingURL=TextInputComponent.js.map