function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

// `PureComponent` is only available in React >= 15.3.0.
var PureComponent = React.PureComponent || React.Component;

// http://react-day-picker.js.org/examples/?yearNavigation
// Component will receive date, locale and localeUtils props
var YearMonthSelect = /*#__PURE__*/function (_PureComponent) {
  _inherits(YearMonthSelect, _PureComponent);
  var _super = _createSuper(YearMonthSelect);
  function YearMonthSelect(props) {
    var _this;
    _classCallCheck(this, YearMonthSelect);
    _this = _super.call(this, props);
    _defineProperty(_assertThisInitialized(_this), "onChangeMonth", function (event) {
      var _this$props = _this.props,
        date = _this$props.date,
        onChange = _this$props.onChange;
      var month = event.target.value;
      if (month !== date.getMonth()) {
        // The date created is in the user's time zone and the time is `00:00`.
        // The `day` is `undefined` which means the first one of the `month`.
        onChange(new Date(date.getFullYear(), month));
      }

      // restoreFocus()
    });
    _defineProperty(_assertThisInitialized(_this), "onChangeYear", function (event) {
      var _this$props2 = _this.props,
        date = _this$props2.date,
        onChange = _this$props2.onChange;
      var year = event.target.value;
      if (year !== date.getFullYear()) {
        // The date created is in the user's time zone and the time is `00:00`.
        // The `day` is `undefined` which means the first one of the `month`.
        onChange(new Date(year, date.getMonth()));
      }

      // restoreFocus()
    });
    _defineProperty(_assertThisInitialized(_this), "restoreFocus", function () {
      var userHasJustChangedYearOrMonth = _this.props.userHasJustChangedYearOrMonth;

      // Doesn't work on iOS.
      // Or maybe it does with the new `focus()` being
      // `focusCalendar()` vs the old `.focus()`.
      // focus()

      // A hack for iOS when it collapses
      // the calendar after selecting a year/month.
      // Known bug: it won't work when a user
      // focuses one `<select/>` and then focuses another one
      // because in that case `onBlur` won't be triggered for the second `<select/>`.
      userHasJustChangedYearOrMonth();
    });
    var _this$props3 = _this.props,
      selectYearsIntoPast = _this$props3.selectYearsIntoPast,
      selectYearsIntoFuture = _this$props3.selectYearsIntoFuture,
      selectedDay = _this$props3.selectedDay,
      localeUtils = _this$props3.localeUtils;

    // The current year in the user's time zone.
    var current_year = new Date().getFullYear();
    var from_year = selectYearsIntoPast ? current_year - selectYearsIntoPast : current_year;
    var to_year = selectYearsIntoFuture ? current_year + selectYearsIntoFuture : current_year;
    var years = new Array(to_year - from_year + 1);
    var i = 0;
    while (from_year + i <= to_year) {
      years[i] = from_year + i;
      i++;
    }

    // Makes sure the currently selected year is in the list
    // to not confuse the user.
    if (selectedDay) {
      var selected_year = selectedDay.getFullYear();
      if (selected_year < from_year) {
        years.unshift(selected_year);
      } else if (selected_year > to_year) {
        years.push(selected_year);
      }
    }
    var months = localeUtils.getMonths();
    _this.months = months;
    _this.years = years;
    return _this;
  }
  _createClass(YearMonthSelect, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
        date = _this$props4.date,
        tabbable = _this$props4.tabbable;
      return /*#__PURE__*/React.createElement("div", {
        className: "DayPicker-Caption"
      }, /*#__PURE__*/React.createElement("div", {
        className: "DayPicker-CaptionSelects"
      }, /*#__PURE__*/React.createElement("div", {
        className: "DayPicker-MonthSelect"
      }, /*#__PURE__*/React.createElement("select", {
        onChange: this.onChangeMonth,
        onBlur: this.restoreFocus,
        value: date.getMonth(),
        "aria-label": "Month",
        tabIndex: tabbable ? 0 : -1,
        className: classNames(
        // `:focus` style is implemented via border color
        // so outline can be muted safely here.
        'rrui__outline', 'rrui__select__native', 'rrui__select__native--overlay')
      }, this.months.map(function (month, i) {
        return /*#__PURE__*/React.createElement("option", {
          key: i,
          value: i
        }, month);
      })), /*#__PURE__*/React.createElement("button", {
        type: "button",
        tabIndex: -1,
        className: classNames('rrui__button-reset', 'rrui__outline', 'rrui__date-picker__month-select-toggler')
      }, /*#__PURE__*/React.createElement("div", {
        className: "rrui__select__selected-content"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rrui__select__selected-label"
      }, this.months[date.getMonth()]), /*#__PURE__*/React.createElement("div", {
        className: "rrui__select__arrow"
      })))), /*#__PURE__*/React.createElement("div", {
        className: "DayPicker-YearSelect"
      }, /*#__PURE__*/React.createElement("select", {
        onChange: this.onChangeYear,
        onBlur: this.restoreFocus,
        value: date.getFullYear(),
        "aria-label": "Year",
        tabIndex: tabbable ? 0 : -1,
        className: classNames(
        // `:focus` style is implemented via border color
        // so outline can be muted safely here.
        'rrui__outline', 'rrui__select__native', 'rrui__select__native--overlay')
      }, this.years.map(function (year, i) {
        return /*#__PURE__*/React.createElement("option", {
          key: i,
          value: year
        }, year);
      })), /*#__PURE__*/React.createElement("button", {
        type: "button",
        tabIndex: -1,
        className: classNames('rrui__button-reset', 'rrui__outline', 'rrui__date-picker__year-select-toggler')
      }, /*#__PURE__*/React.createElement("div", {
        className: "rrui__select__selected-content"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rrui__select__selected-label"
      }, date.getFullYear()), /*#__PURE__*/React.createElement("div", {
        className: "rrui__select__arrow"
      }))))));
    }
  }]);
  return YearMonthSelect;
}(PureComponent);
_defineProperty(YearMonthSelect, "propTypes", {
  date: PropTypes.instanceOf(Date),
  onChange: PropTypes.func.isRequired,
  localeUtils: PropTypes.object,
  tabbable: PropTypes.bool.isRequired
});
_defineProperty(YearMonthSelect, "defaultProps", {
  // For some weird reason in Chrome 70
  // the focus is trapped and jumps from
  // the month `<select/>` back to the `<input/>`
  // if `tabbable` is `true`.
  // Works as intended in Firefox though.
  tabbable: false
});
export { YearMonthSelect as default };
//# sourceMappingURL=YearMonthSelect.js.map